
; CC5X Version 3.3, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   8. Apr 2008  15:06  *************

        processor  16F628
        radix  DEC

        __config 0x3F45

INDF        EQU   0x00
PCL         EQU   0x02
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
T0IF        EQU   2
GIE         EQU   7
OPTION_REG  EQU   0x81
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
T1CON       EQU   0x10
CCPR1L      EQU   0x15
CCPR1H      EQU   0x16
CCP1CON     EQU   0x17
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
CMCON       EQU   0x1F
TXSTA       EQU   0x98
SPBRG       EQU   0x99
EEDATA      EQU   0x9A
EEADR       EQU   0x9B
EECON2      EQU   0x9D
VRCON       EQU   0x9F
PEIE        EQU   6
CCP1IF      EQU   2
TXIF        EQU   4
RCIF        EQU   5
TMR1ON      EQU   0
CREN        EQU   4
CCP1IE      EQU   2
RD          EQU   0
WR          EQU   1
WREN        EQU   2
jIsrGlobals EQU   0x69
wTick10Length EQU   0x6C
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
bAddr       EQU   0x63
bData       EQU   0x64
p           EQU   0x65
bData_2     EQU   0x65
b           EQU   0x66
bSymbolIndex EQU   0x65
bBitPairPos EQU   0x66
bSymbol     EQU   0x65
C1cnt       EQU   0x67
bTmp        EQU   0x63
bSymIx      EQU   0x64
bVarCode    EQU   0x63
qOkay       EQU   0
bVarCode_2  EQU   0x63
bTickDiv    EQU   0x22
bSecondsToTimeout EQU   0x23
bState      EQU   0x24
bRx         EQU   0x25
bCmd        EQU   0x26
bDigitCnt   EQU   0x27
bShifter    EQU   0x28
ulP         EQU   0x29
wQ          EQU   0x2D
wR          EQU   0x2F
wS          EQU   0x31
wU          EQU   0x5C
bV          EQU   0x5E
wW          EQU   0x5F
qP_Updated  EQU   0
qQ_Updated  EQU   1
qR_Updated  EQU   2
qS_Updated  EQU   3
qT_Updated  EQU   4
qU_Updated  EQU   5
qV_Updated  EQU   6
qW_Updated  EQU   7
qBurnOk     EQU   0
C2cnt       EQU   0x63
C3cnt       EQU   0x63
C4cnt       EQU   0x63
C5cnt       EQU   0x63
C6cnt       EQU   0x63
C7cnt       EQU   0x63
ulNewPhaseIncrement EQU   0x2B
bLoop       EQU   0x2F
bSym        EQU   0x24
ulPhInc     EQU   0x25
wOffset     EQU   0x29
bNmeaState  EQU   0x6E
bHour       EQU   0x6F
bMinute     EQU   0x6F
bSecond     EQU   0x71
bRx_2       EQU   0x22
bSymbolIndex_2 EQU   0x72
wRand       EQU   0x73
qPrevExtSyncSample EQU   0
qExtSyncEdge EQU   0
wTxProbability EQU   0x22
ci          EQU   0x67

        GOTO main

  ; FILE C:\Work\MEPT_JT\v002\mjb002.c
                        ;/*
                        ; *      #####################################################################
                        ; *
                        ; *        Copyright (C) 2008  Johan H. Bodin SM6LKM
                        ; *
                        ; *        This software is provided 'as is', without warranty of any kind,
                        ; *        express or implied. In no event shall the author be held liable
                        ; *        for any damages arising from the use of this software.
                        ; *
                        ; *        Permission to use, copy, modify, and distribute this software and
                        ; *        its documentation for non-commercial purposes is hereby granted,
                        ; *        provided that the above copyright notice and this disclaimer appear
                        ; *        in all copies and supporting documentation.
                        ; *
                        ; *        The software must NOT be sold or used as part of any commercial
                        ; *        or "non-free" product.
                        ; *
                        ; *      #####################################################################
                        ; */
                        ;
                        ;
                        ;/*******************************************************************************
                        ;
                        ;        Project:
                        ;          MEPT_JT Beacon Controller for AD9850 DDS and/or VCXO exciter.
                        ;
                        ;        File:
                        ;          mjb###.c
                        ;
                        ;        Author:
                        ;          Johan Bodin SM6LKM
                        ;
                        ;        Processor:
                        ;          PIC16F628
                        ;
                        ;        Clock:
                        ;           3.6864MHz crystal in XT mode
                        ;
                        ;        Compiler:
                        ;          BKD CC5X C v3.3 extended edition
                        ;
                        ;        Dependencies:
                        ;          16c628.h (supplied with compiler)
                        ;          int16cxx.h (supplied with compiler)
                        ;
                        ;        Known bugs or limitations:
                        ;          None.
                        ;
                        ;        - Revision history -
                        ;        ==============================================================
                        ;        Version  Date    Comment / Programmer
                        ;        --------------------------------------------------------------
                        ;        0.00     080313  Created /JHB
                        ;        0.01     080331  Big bang test, seems to work OK /JHB
                        ;        0.02     080402  - Added programmable random timeslot TX.
                        ;                         - Enabled PORTB internal weak pull-up.
                        ;                         - Added external UTC sync on RB3 --_--.
                        ;                         - Turned off the LEDs after WRITE command.
                        ;                         - Added new commands for VCXO adjustment.
                        ;                         - Added MEPT_JT baudrate calibration.
                        ;                         - Some minor fixes. /JHB
                        ;        ==============================================================
                        ;
                        ;*******************************************************************************/
                        ;
                        ;#include <16f628.h>
                        ;#include <int16cxx.h>
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Set PIC configuration word
                        ; *
                        ; *      Cc  = CP1:CP0, code protection
                        ; *              11 = code protection OFF
                        ; *              10 = 0x400-0x7FF protected (upper half)
                        ; *              01 = 0x200-0x7FF protected (upper 3/4)
                        ; *              00 = 0x000-0x7FF protected (entire code space)
                        ; *
                        ; *      E   = CPD, data EEPROM protection
                        ; *              1 = unprotected
                        ; *              0 = protected
                        ; *
                        ; *      L   = LVP, low voltage programming
                        ; *              1 = enabled, RB4 has PGM function
                        ; *              0 = disabled, RB4 is digital I/O
                        ; *
                        ; *      B   = BODEN, brown-out detector
                        ; *              1 = enabled
                        ; *              0 = disabled
                        ; *
                        ; *      M   = MCLRE, RA5/MCLR pin function select
                        ; *              1 = RA5 pin is /MCLR
                        ; *              0 = RA5 pin is digital input, /MCLR internally tied to Vdd
                        ; *
                        ; *      P   = /PWRTE, power-up timer
                        ; *              1 = disabled
                        ; *              0 = enabled
                        ; *
                        ; *      W   = WDTE, watchdog timer
                        ; *              1 = enabled
                        ; *              0 = disabled
                        ; *
                        ; *      XYZ = FOSC2:FOSC1:FOSC0, oscillator selection
                        ; *              111 = ER, CLKOUT on RA6, resistor on RA7
                        ; *              110 = ER, I/O on RA6, resistor on RA7
                        ; *              101 = INTRC, CLKOUT on RA6, I/O on RA7
                        ; *              100 = INTRC,I/O on RA6, I/O on RA7
                        ; *              011 = EC, I/O on RA6, CLKIN on RA7
                        ; *              010 = HS, crystal/resonator on RA6 and RA7
                        ; *              001 = XT, crystal/resonator on RA6 and RA7
                        ; *              000 = LP, crystal/resonator on RA6 and RA7
                        ; */
                        ;
                        ;// CP off
                        ;// EP off
                        ;// LVP off
                        ;// BOD on
                        ;// MCLR off
                        ;// PWRT on
                        ;// WDT on
                        ;// OSC xt
                        ;                 // CcCc-ELBMXPWYZ
                        ;#pragma config |= 0b11111101000101
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Some funny #defines...
                        ; */
                        ;
                        ;#define FALSE   0
                        ;#define TRUE    1
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      EEPROM map
                        ; *
                        ; *      PIC16F628 has 128 bytes of EEPROM memory
                        ; *
                        ; *      Notes:
                        ; *        EEPROM[eaSYMBOLTABLE..eaSYMBOLTABLE+40] contains the MEPT_JT message.
                        ; *        The two LSBits (bits 1..0) of the first byte contains the first symbol.
                        ; *
                        ; *        EEPROM[eaBASEPHINC..eaBASEPHINC+3] contains the DDS phase increment to
                        ; *        use for the lowest FSK frequency (when symbol == 0). LSByte is stored
                        ; *        first.
                        ; *
                        ; *        EEPROM[eaFSKOFFSETS..eaFSKOFFSETS+5] contains three 16-bit unsigned
                        ; *        DDS phase increment offsets to use for symbols 1..3, in that order.
                        ; *        LSByte is stored first.
                        ; *
                        ; *        EEPROM[eaGPSBAUDCODE] contains the GPS baudrate selector:
                        ; *          0x00 => 1200 baud
                        ; *          0x01 => 2400 baud
                        ; *          0x02 => 4800 baud
                        ; *          0x03 => 9600 baud
                        ; *          0x04 => 19200 baud
                        ; *
                        ; *          All other values defaults to 9600 baud.
                        ; *
                        ; *        EEPROM[eaTXPROB..eaTXPROB+1] contains the "TX probability".
                        ; *        0x0000..0xFFFF corresponds to 0..100%. LSByte is stored first.
                        ; *
                        ; *        EEPROM[eaBAUDCAL..eaBAUDCAL+1] contains the MEPT_JT baudrate
                        ; *        calibration constant. Signed value. LSByte is stored first.
                        ; */
                        ;
                        ;#define eaSYMBOLTABLE   0     // 41 bytes used, next free location is 41
                        ;#define eaBASEPHINC     41    // 4 bytes used, next free location is 45
                        ;#define eaFSKOFFSETS    45    // 6 bytes used, next free location is 51
                        ;#define eaGPSBAUDCODE   51    // 1 byte used, next free location is 52
                        ;#define eaTXPROB        52    // 2 bytes used, next free location is 54
                        ;#define eaBAUDCAL       54    // 2 bytes used, next free location is 56
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      EEPROM initialization (at programming time)
                        ; */
                        ;
                        ;//#define eeBASE 0x2100         // EEPROM start word address for hex file
                        ;
                        ;//#pragma cdata[eeBASE+eaDUMMY] = 0x00
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      I/O pin assignments
                        ; *
                        ; *      RA7 - Configured as oscillator input pin
                        ; *      RA6 - Configured as oscillator output pin
                        ; *      RA5 - Unused, configured as normal input with 22k pull-up (also VPP)
                        ; *      RA4 - Output, green LED, 0 = ON
                        ; *      RA3 - Output, red LED, 0 = ON
                        ; *      RA2 - Output, transmitter key, 1 = transmit
                        ; *      RA1 - Output, FSK MSBit for VCXO transmitter, 1 = +2.9297 Hz
                        ; *      RA0 - Output, FSK LSBit for VCXO transmitter, 1 = +1.4648 Hz
                        ; *
                        ; *      RB7 - Output, /SDATA to AD9850 DDS (also ICSP data I/O)
                        ; *      RB6 - Output, /SCLK to AD9850 DDS (also ICSP clock input)
                        ; *      RB5 - Output, /FQ_UD strobe to AD9850 DDS
                        ; *      RB4 - Output, /RESET to AD9850 DDS
                        ; *      RB3 - Input, external sync, active low
                        ; *      RB2 - Output, UART TX
                        ; *      RB1 - Input, UART RX
                        ; *      RB0 - Unused, configured as output, driven low
                        ; *
                        ; *      Note:
                        ; *        The DDS control signals on RB7..RB4 are INVERTED because
                        ; *        there are inverting buffers on SM6LKM's DDS board!
                        ; */
                        ;
                        ;// Pin access macros
                        ;
                        ;#define oGLEDn        PORTA.4
                        ;#define oRLEDn        PORTA.3
                        ;#define oTX_KEY       PORTA.2
                        ;
                        ;#define oDDS_SDATAn   PORTB.7
                        ;#define oDDS_SCLKn    PORTB.6
                        ;#define oDDS_STROBEn  PORTB.5
                        ;#define oDDS_RESETn   PORTB.4
                        ;#define oEXT_SYNCn    PORTB.3
                        ;
                        ;#define LEDSOFF_KEYOFF_FSKZERO  PORTA = 0b00011000;
                        ;
                        ;// VCXO output stuff
                        ;
                        ;#define VCXOPORT      PORTA
                        ;#define bnVCXO_D1     1           // bit numbers in VCXOPORT
                        ;#define bnVCXO_D0     0
                        ;#define bmVCXOMASK    0b00000011  // bit mask for VCXOPORT
                        ;
                        ;//  Initial output pin levels
                        ;
                        ;#define PORTA_INIT  0b00011000  // LEDs off
                        ;#define PORTB_INIT  0b11110000  // all DDS signals low (after the inverters...)
                        ;
                        ;//  Initial pin directions, 0 = OUTPUT
                        ;
                        ;//    Note:
                        ;//      There's a quirk in the PIC16F627/628, TRISB.1 and TRISB.2 *BOTH*
                        ;//      have to be set (input mode) for the UART I/O to work correctly.
                        ;//      In other words, the TX pin has to be configured as input as well
                        ;//      as the RX pin...
                        ;
                        ;#define TRISA_INIT  0b11100000
                        ;#define TRISB_INIT  0b00001110
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Global variables
                        ; *
                        ; *      PIC16F628 has 224 bytes of RAM in three banks:
                        ; *
                        ; *        Bank 0: 0x20-0x7F, 96 bytes including 16 bytes in the common area
                        ; *        Bank 1: 0xA0-0xEF, 80 bytes (plus 16 bytes in the common area)
                        ; *        Bank 2: 0x120-0x14F, 48 bytes (plus 16 bytes in the common area)
                        ; *        Bank 3: Nothing (plus 16 bytes in the common area)
                        ; *
                        ; *        Common area: 0x70-0x7F/0xF0-0xFF/0x170-0x17F/0x1F0-0x1FF, 16 bytes
                        ; */
                        ;
                        ;bank0 struct
                        ;{
                        ;  char bNextVcxoSymbol;
                        ;  char bTickCycleCount;
                        ;  bit qNewFreqInQueue;
                        ;  bit qPleaseQRT;
                        ;} jIsrGlobals;
                        ;
                        ;bank0 uns16 wTick10Length;
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Interrupt Service Routine
                        ; *
                        ; *      This is a tick ISR driven by CCP1 compare interrupt
                        ; *
                        ; *      Tsymbol = 8192/12000 = 0.68266666... s
                        ; *      CPU Tcy = 4/3.6864e6 = 1,08506944444...e-6 s
                        ; *      Tcy count per symbol = (8192/12000) / (4/3.6864e6) = 629145.6
                        ; *      TMR1 is running without prescaler => full TMR1 cycle = 65536 Tcy
                        ; *      Tsymbol happens to be exactly 9.6 full TMR1 cycles.
                        ; *      0.6 cycles = 0.6 * 65536 = 39321.6 Tcy which rounds to 39322.
                        ; *
                        ; *      With calibration constant set to zero, the optimum Fxtal = 4/Tcy =
                        ; *      4 / ((8192/12000) / 629146) = 3.68640234375 MHz.
                        ; *      The purist may wish to pull the rock +2.3 Hz... ;-D
                        ; *
                        ; *      If the clock is too much off target, and you don't want to pull
                        ; *      the crystal "physically", you can use the software calibration:
                        ; *
                        ; *        CAL_VALUE (command W) = 64*Fxtal/375 - 629146
                        ; *
                        ; *      Note:
                        ; *        The main loop loads global wTick10Length with a calibrated Tcy
                        ; *        count (39322 +/- calibration) just before starting transmission.
                        ; */
                        ;
                        ;#pragma origin 4
        ORG 0x0004
                        ;
                        ;interrupt vIntServer (void)
                        ;{
vIntServer
                        ;  int_save_registers                        // save W and STATUS
        MOVWF svrWREG
        SWAPF STATUS,W
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF svrSTATUS
                        ;
                        ;  if (--jIsrGlobals.bTickCycleCount == 0)   // 10:th tick = time for symbol transition?
        DECFSZ jIsrGlobals+1,1
        GOTO  m003
                        ;  {
                        ;    // Update outputs *first* to avoid time jitter due to non-isochronous
                        ;    // code below. The main loop has already loaded a new frequency into
                        ;    // the DDS chip and a new VCXO FSK symbol into jIsrGlobals.bNextVcxoSymbol.
                        ;
                        ;    VCXOPORT = jIsrGlobals.bNextVcxoSymbol | (VCXOPORT & ~bmVCXOMASK);  // VCXO QSY!
        MOVLW .252
        ANDWF PORTA,W
        IORWF jIsrGlobals,W
        MOVWF PORTA
                        ;    oTX_KEY = 1;                            // make sure VCXO transmitter is ON
        BSF   PORTA,2
                        ;
                        ;    oDDS_STROBEn = 0;                       // DDS QSY!
        BCF   PORTB,5
                        ;    oDDS_STROBEn = 1;
        BSF   PORTB,5
                        ;
                        ;    jIsrGlobals.qNewFreqInQueue = FALSE;    // it is now OK to load new a symbol
        BCF   jIsrGlobals+2,0
                        ;
                        ;    if (jIsrGlobals.qPleaseQRT)             // was this the end of the last symbol?
        BTFSS jIsrGlobals+2,1
        GOTO  m001
                        ;    {
                        ;      oTX_KEY = 0;                          // yes, turn off VCXO transmitter
        BCF   PORTA,2
                        ;      CCP1IE = 0;                           // no more interrupts please
        BSF   0x03,RP0
        BCF   0x8C,CCP1IE
                        ;      oRLEDn = 1;                           // red LED off
        BCF   0x03,RP0
        BSF   PORTA,3
                        ;    }
                        ;    else                                    // there is more to send so...
        GOTO  m002
                        ;      oRLEDn = !oRLEDn;                     // ...toggle red LED at each symbol start
m001    MOVLW .8
        XORWF PORTA,1
                        ;
                        ;    // Every 10:th tick cycle should be shorter than a full TMR1 count
                        ;
                        ;    CCPR1L += wTick10Length.low8;           // schedule next tick
m002    MOVF  wTick10Length,W
        ADDWF CCPR1L,1
                        ;    if (Carry)                              // propagate carry to MSByte
        BTFSC 0x03,Carry
                        ;      CCPR1H++;
        INCF  CCPR1H,1
                        ;    CCPR1H += wTick10Length.high8;
        MOVF  wTick10Length+1,W
        ADDWF CCPR1H,1
                        ;
                        ;    CCP1IF = 0;                             // clear interrupt flag
        BCF   0x0C,CCP1IF
                        ;    jIsrGlobals.bTickCycleCount = 10;       // 10 ticks per baud (well, 9.6...)
        MOVLW .10
        MOVWF jIsrGlobals+1
                        ;  }
                        ;/********
                        ;  else
                        ;  {
                        ;    Adding 65536 to CCPR1H:CCPR1L is stupid as it won't change a 16-bit value ;-)
                        ;  }
                        ;********/
                        ;
                        ;  CCP1IF = 0;                 // clear the CCP1 interrupt flag
m003    BCF   0x0C,CCP1IF
                        ;
                        ;  int_restore_registers       // restore W and STATUS
        SWAPF svrSTATUS,W
        MOVWF STATUS
        SWAPF svrWREG,1
        SWAPF svrWREG,W
                        ;}
        RETFIE
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Read on-chip EEPROM
                        ; *
                        ; *      Argument:
                        ; *        W = EEPROM address, 0x00..0x7F
                        ; *
                        ; *      Return:
                        ; *        EEPROM data read from address bAddr
                        ; */
                        ;
                        ;char bReadEE (char W)
                        ;{
_const1
        MOVLW .1
        SUBWF ci+1,W
        BTFSS 0x03,Carry
        GOTO  m004
        BTFSS 0x03,Zero_
        RETLW .0
        MOVLW .197
        SUBWF ci,W
        BTFSC 0x03,Carry
        RETLW .0
m004    MOVF  ci+1,W
        MOVWF PCLATH
        MOVF  ci,W
        ADDLW .61
        BTFSC 0x03,Carry
        INCF  PCLATH,1
        MOVWF PCL
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .70
        RETLW .114
        RETLW .101
        RETLW .113
        RETLW .117
        RETLW .101
        RETLW .110
        RETLW .99
        RETLW .105
        RETLW .101
        RETLW .115
        RETLW .58
        RETLW .13
        RETLW .10
        RETLW .32
        RETLW .32
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .32
        RETLW .32
        RETLW .83
        RETLW .121
        RETLW .109
        RETLW .98
        RETLW .111
        RETLW .108
        RETLW .32
        RETLW .48
        RETLW .32
        RETLW .68
        RETLW .68
        RETLW .83
        RETLW .32
        RETLW .80
        RETLW .104
        RETLW .73
        RETLW .110
        RETLW .99
        RETLW .32
        RETLW .40
        RETLW .80
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .32
        RETLW .32
        RETLW .83
        RETLW .121
        RETLW .109
        RETLW .98
        RETLW .111
        RETLW .108
        RETLW .32
        RETLW .49
        RETLW .32
        RETLW .68
        RETLW .68
        RETLW .83
        RETLW .32
        RETLW .79
        RETLW .102
        RETLW .102
        RETLW .115
        RETLW .101
        RETLW .116
        RETLW .32
        RETLW .40
        RETLW .81
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .43
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .32
        RETLW .32
        RETLW .83
        RETLW .121
        RETLW .109
        RETLW .98
        RETLW .111
        RETLW .108
        RETLW .32
        RETLW .50
        RETLW .32
        RETLW .68
        RETLW .68
        RETLW .83
        RETLW .32
        RETLW .79
        RETLW .102
        RETLW .102
        RETLW .115
        RETLW .101
        RETLW .116
        RETLW .32
        RETLW .40
        RETLW .82
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .43
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .32
        RETLW .32
        RETLW .83
        RETLW .121
        RETLW .109
        RETLW .98
        RETLW .111
        RETLW .108
        RETLW .32
        RETLW .51
        RETLW .32
        RETLW .68
        RETLW .68
        RETLW .83
        RETLW .32
        RETLW .79
        RETLW .102
        RETLW .102
        RETLW .115
        RETLW .101
        RETLW .116
        RETLW .32
        RETLW .40
        RETLW .83
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .43
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .77
        RETLW .101
        RETLW .115
        RETLW .115
        RETLW .97
        RETLW .103
        RETLW .101
        RETLW .32
        RETLW .40
        RETLW .84
        RETLW .41
        RETLW .58
        RETLW .13
        RETLW .10
        RETLW .32
        RETLW .32
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .84
        RETLW .88
        RETLW .32
        RETLW .80
        RETLW .114
        RETLW .111
        RETLW .98
        RETLW .97
        RETLW .98
        RETLW .105
        RETLW .108
        RETLW .105
        RETLW .116
        RETLW .121
        RETLW .32
        RETLW .40
        RETLW .85
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .32
        RETLW .111
        RETLW .117
        RETLW .116
        RETLW .32
        RETLW .111
        RETLW .102
        RETLW .32
        RETLW .48
        RETLW .120
        RETLW .70
        RETLW .70
        RETLW .70
        RETLW .70
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .71
        RETLW .80
        RETLW .83
        RETLW .32
        RETLW .66
        RETLW .97
        RETLW .117
        RETLW .100
        RETLW .32
        RETLW .82
        RETLW .97
        RETLW .116
        RETLW .101
        RETLW .32
        RETLW .67
        RETLW .111
        RETLW .100
        RETLW .101
        RETLW .32
        RETLW .40
        RETLW .86
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .49
        RETLW .50
        RETLW .48
        RETLW .48
        RETLW .0
        RETLW .50
        RETLW .52
        RETLW .48
        RETLW .48
        RETLW .0
        RETLW .52
        RETLW .56
        RETLW .48
        RETLW .48
        RETLW .0
        RETLW .57
        RETLW .54
        RETLW .48
        RETLW .48
        RETLW .0
        RETLW .49
        RETLW .57
        RETLW .50
        RETLW .48
        RETLW .48
        RETLW .0
        RETLW .41
        RETLW .13
        RETLW .10
        RETLW .66
        RETLW .97
        RETLW .117
        RETLW .100
        RETLW .32
        RETLW .67
        RETLW .97
        RETLW .108
        RETLW .32
        RETLW .40
        RETLW .87
        RETLW .41
        RETLW .58
        RETLW .32
        RETLW .48
        RETLW .120
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .0
        RETLW .32
        RETLW .117
        RETLW .112
        RETLW .100
        RETLW .97
        RETLW .116
        RETLW .101
        RETLW .100
        RETLW .32
        RETLW .79
        RETLW .75
        RETLW .0
        RETLW .32
        RETLW .70
        RETLW .97
        RETLW .105
        RETLW .108
        RETLW .101
        RETLW .100
        RETLW .33
        RETLW .32
        RETLW .45
        RETLW .32
        RETLW .69
        RETLW .69
        RETLW .80
        RETLW .82
        RETLW .79
        RETLW .77
        RETLW .32
        RETLW .101
        RETLW .114
        RETLW .114
        RETLW .111
        RETLW .114
        RETLW .33
        RETLW .0
        RETLW .32
        RETLW .78
        RETLW .79
        RETLW .84
        RETLW .32
        RETLW .117
        RETLW .112
        RETLW .100
        RETLW .97
        RETLW .116
        RETLW .101
        RETLW .100
        RETLW .33
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .77
        RETLW .74
        RETLW .66
        RETLW .32
        RETLW .118
        RETLW .48
        RETLW .48
        RETLW .50
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .67
        RETLW .117
        RETLW .114
        RETLW .114
        RETLW .101
        RETLW .110
        RETLW .116
        RETLW .32
        RETLW .83
        RETLW .101
        RETLW .116
        RETLW .116
        RETLW .105
        RETLW .110
        RETLW .103
        RETLW .115
        RETLW .58
        RETLW .13
        RETLW .10
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .69
        RETLW .110
        RETLW .116
        RETLW .101
        RETLW .114
        RETLW .32
        RETLW .43
        RETLW .43
        RETLW .43
        RETLW .43
        RETLW .32
        RETLW .102
        RETLW .111
        RETLW .114
        RETLW .32
        RETLW .99
        RETLW .109
        RETLW .100
        RETLW .32
        RETLW .109
        RETLW .111
        RETLW .100
        RETLW .101
        RETLW .46
        RETLW .46
        RETLW .46
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .13
        RETLW .10
        RETLW .78
        RETLW .101
        RETLW .119
        RETLW .32
        RETLW .83
        RETLW .101
        RETLW .116
        RETLW .116
        RETLW .105
        RETLW .110
        RETLW .103
        RETLW .115
        RETLW .58
        RETLW .13
        RETLW .10
        RETLW .0
        RETLW .13
        RETLW .10
        RETLW .83
        RETLW .116
        RETLW .97
        RETLW .114
        RETLW .116
        RETLW .105
        RETLW .110
        RETLW .103
        RETLW .32
        RETLW .98
        RETLW .101
        RETLW .97
        RETLW .99
        RETLW .111
        RETLW .110
        RETLW .46
        RETLW .46
        RETLW .46
        RETLW .13
        RETLW .10
        RETLW .0
bReadEE
                        ;  EEADR = W;          // load EEPROM address
        BSF   0x03,RP0
        MOVWF EEADR
                        ;  RD = 1;             // read EEPROM
        BSF   0x9C,RD
                        ;  return EEDATA;      // return read data
        MOVF  EEDATA,W
        BCF   0x03,RP0
        RETURN
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Write on-chip EEPROM
                        ; *
                        ; *      Argument:
                        ; *        bAddr = EEPROM address, 0x00..0x7F
                        ; *        bData = Data to be written
                        ; *
                        ; *      Return:
                        ; *        TRUE if written data verifies OK, else FALSE
                        ; *
                        ; *      Note:
                        ; *        PEIE related interrupts will be disabled for 6 Tcy!
                        ; *        (never mind... the interrupt is not running when writing to EEPROM anyway...)
                        ; */
                        ;
                        ;bit qWriteEE (char bAddr, char bData)
                        ;{
qWriteEE
        MOVWF bData
                        ;  EEDATA = bData;     // load EEPROM data byte
        BSF   0x03,RP0
        MOVWF EEDATA
                        ;  EEADR = bAddr;      // load EEPROM address
        BCF   0x03,RP0
        MOVF  bAddr,W
        BSF   0x03,RP0
        MOVWF EEADR
                        ;  WREN = 1;           // enable EEPROM write
        BSF   0x9C,WREN
                        ;  PEIE = 0;           // magic unlock sequence must be atomic
        BCF   0x0B,PEIE
                        ;  EECON2 = 0x55;      // unlock
        MOVLW .85
        MOVWF EECON2
                        ;  EECON2 = 0xAA;
        MOVLW .170
        MOVWF EECON2
                        ;  WR = 1;             // start write operation
        BSF   0x9C,WR
                        ;  PEIE = 1;           // allow interrupts again
        BSF   0x0B,PEIE
                        ;  WREN = 0;           // disable EEPROM write
        BCF   0x9C,WREN
                        ;  do                  // wait for EEPROM "write complete"
                        ;    clrwdt ();
m005    CLRWDT
                        ;  while (WR);
        BTFSC 0x9C,WR
        GOTO  m005
                        ;  RD = 1;             // read back written data for verification
        BSF   0x9C,RD
                        ;  return (EEDATA == bData); // return verification result
        BCF   0x03,Carry
        MOVF  EEDATA,W
        BCF   0x03,RP0
        XORWF bData,W
        BTFSC 0x03,Zero_
        BSF   0x03,Carry
        RETURN
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Serial output
                        ; */
                        ;
                        ;void vPut (char W)
                        ;{
vPut
                        ;  while (!TXIF)
m006    BTFSC 0x0C,TXIF
        GOTO  m007
                        ;    clrwdt ();
        CLRWDT
        GOTO  m006
                        ;  TXREG = W;
m007    MOVWF TXREG
                        ;}
        RETURN
                        ;
                        ;
                        ;void vPrint (const char *p)
                        ;{
vPrint
                        ;  while (*p)
m008    MOVF  p,W
        MOVWF ci
        MOVF  p+1,W
        MOVWF ci+1
        CALL  _const1
        XORLW .0
        BTFSC 0x03,Zero_
        GOTO  m009
                        ;    vPut (*p++);
        MOVF  p,W
        MOVWF ci
        MOVF  p+1,W
        MOVWF ci+1
        CALL  _const1
        CALL  vPut
        INCF  p,1
        BTFSC 0x03,Zero_
        INCF  p+1,1
        GOTO  m008
                        ;}
m009    RETURN
                        ;
                        ;
                        ;void vPutHexByte (char bData)
                        ;{
vPutHexByte
        MOVWF bData_2
                        ;  char b;
                        ;
                        ;  b = bData >> 4;
        SWAPF bData_2,W
        ANDLW .15
        MOVWF b
                        ;  if (b > 9)
        MOVLW .10
        SUBWF b,W
        BTFSS 0x03,Carry
        GOTO  m010
                        ;    b += 55;
        MOVLW .55
        ADDWF b,1
                        ;  else
        GOTO  m011
                        ;    b += 48;
m010    MOVLW .48
        ADDWF b,1
                        ;  vPut (b);
m011    MOVF  b,W
        CALL  vPut
                        ;
                        ;  b = bData & 0x0F;
        MOVLW .15
        ANDWF bData_2,W
        MOVWF b
                        ;  if (b > 9)
        MOVLW .10
        SUBWF b,W
        BTFSS 0x03,Carry
        GOTO  m012
                        ;    b += 55;
        MOVLW .55
        ADDWF b,1
                        ;  else
        GOTO  m013
                        ;    b += 48;
m012    MOVLW .48
        ADDWF b,1
                        ;  vPut (b);
m013    MOVF  b,W
        GOTO  vPut
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Read a symbol from EEPROM
                        ; *
                        ; *      Argument:
                        ; *        bSymbolIndex = sequential symbol number, 0..161
                        ; *
                        ; *      Return value:
                        ; *        FSK value 0..3 (0 corresponds to the lowest transmitted frequency)
                        ; */
                        ;
                        ;char bGetSymbol (char bSymbolIndex)
                        ;{
bGetSymbol
        MOVWF bSymbolIndex
                        ;  char bBitPairPos;
                        ;  char bSymbol @ bSymbolIndex;        // reuse a variable but change name - may save a RAM byte ;-)
                        ;
                        ;  bBitPairPos = bSymbolIndex & 0x03;  // symbol position within EEPROM byte
        MOVLW .3
        ANDWF bSymbolIndex,W
        MOVWF bBitPairPos
                        ;  bSymbolIndex /= 4;                  // byte offset in EEPROM table
        BCF   0x03,Carry
        RRF   bSymbolIndex,1
        BCF   0x03,Carry
        RRF   bSymbolIndex,1
                        ;  bSymbolIndex += eaSYMBOLTABLE;      // add base address of symbol table
                        ;  bSymbol = bReadEE (bSymbolIndex);   // read 1 byte = 4 symbols from EEPROM
        MOVF  bSymbolIndex,W
        CALL  bReadEE
        MOVWF bSymbol
                        ;  bBitPairPos *= 2;                   // two bits per bit pair...
        BCF   0x03,Carry
        RLF   bBitPairPos,1
                        ;  bSymbol >>= bBitPairPos;            // shift the wanted symbol into bits 1..0
        MOVF  bBitPairPos,W
        BTFSC 0x03,Zero_
        GOTO  m015
        MOVWF C1cnt
m014    BCF   0x03,Carry
        RRF   bSymbol,1
        DECFSZ C1cnt,1
        GOTO  m014
                        ;  return bSymbol & 0x03;              // mask off unwanted stuff
m015    MOVLW .3
        ANDWF bSymbol,W
        RETURN
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Dump all EEPROM settings on the serial port
                        ; */
                        ;
                        ;void vDumpSettings (void)
                        ;{
vDumpSettings
                        ;  char bTmp;
                        ;  char bSymIx;
                        ;
                        ;  bTmp = 60;
        MOVLW .60
        MOVWF bTmp
                        ;  do
                        ;    vPut ('=');
m016    MOVLW .61
        CALL  vPut
                        ;  while (--bTmp);
        DECFSZ bTmp,1
        GOTO  m016
                        ;
                        ;  vPrint ("\r\n\r\nFrequencies:\r\n  ");
        CLRF  p
        CLRF  p+1
        CALL  vPrint
                        ;  bTmp = 34;
        MOVLW .34
        MOVWF bTmp
                        ;  do
                        ;    vPut ('-');
m017    MOVLW .45
        CALL  vPut
                        ;  while (--bTmp);
        DECFSZ bTmp,1
        GOTO  m017
                        ;  vPrint ("\r\n  Symbol 0 DDS PhInc (P): 0x");
        MOVLW .21
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  vPutHexByte (bReadEE (eaBASEPHINC+3));  // show MSByte first
        MOVLW .44
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaBASEPHINC+2));
        MOVLW .43
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaBASEPHINC+1));
        MOVLW .42
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaBASEPHINC));
        MOVLW .41
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPrint ("\r\n  Symbol 1 DDS Offset (Q): +0x");
        MOVLW .52
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  vPutHexByte (bReadEE (eaFSKOFFSETS+1)); // show MSByte first
        MOVLW .46
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaFSKOFFSETS));
        MOVLW .45
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPrint ("\r\n  Symbol 2 DDS Offset (R): +0x");
        MOVLW .85
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  vPutHexByte (bReadEE (eaFSKOFFSETS+3));
        MOVLW .48
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaFSKOFFSETS+2));
        MOVLW .47
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPrint ("\r\n  Symbol 3 DDS Offset (S): +0x");
        MOVLW .118
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  vPutHexByte (bReadEE (eaFSKOFFSETS+5));
        MOVLW .50
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaFSKOFFSETS+4));
        MOVLW .49
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPrint ("\r\n  ");
        MOVLW .16
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  bTmp = 34;
        MOVLW .34
        MOVWF bTmp
                        ;  do
                        ;    vPut ('-');
m018    MOVLW .45
        CALL  vPut
                        ;  while (--bTmp);
        DECFSZ bTmp,1
        GOTO  m018
                        ;  vPrint ("\r\n\r\nMessage (T):\r\n  ");
        MOVLW .151
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  bTmp = 49;
        MOVLW .49
        MOVWF bTmp
                        ;  do
                        ;    vPut ('-');
m019    MOVLW .45
        CALL  vPut
                        ;  while (--bTmp);
        DECFSZ bTmp,1
        GOTO  m019
                        ;  vPrint ("\r\n  ");
        MOVLW .16
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  bSymIx = 0;
        CLRF  bSymIx
                        ;  bTmp = 0;
        CLRF  bTmp
                        ;  for (;;)
                        ;  {
                        ;    vPut (bGetSymbol (bSymIx) + '0');
m020    MOVF  bSymIx,W
        CALL  bGetSymbol
        ADDLW .48
        CALL  vPut
                        ;    bSymIx++;
        INCF  bSymIx,1
                        ;    if (bSymIx == 162)
        MOVF  bSymIx,W
        XORLW .162
        BTFSC 0x03,Zero_
                        ;      break;
        GOTO  m022
                        ;    bTmp++;
        INCF  bTmp,1
                        ;    if (bTmp == 40)
        MOVF  bTmp,W
        XORLW .40
        BTFSS 0x03,Zero_
        GOTO  m021
                        ;    {
                        ;      bTmp = 0;
        CLRF  bTmp
                        ;      vPrint ("\r\n  ");
        MOVLW .16
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;    }
                        ;    else
        GOTO  m020
                        ;    if ((bTmp & 0x03) == 0)
m021    MOVLW .3
        ANDWF bTmp,W
        BTFSS 0x03,Zero_
        GOTO  m020
                        ;      vPut (32);
        MOVLW .32
        CALL  vPut
                        ;  }
        GOTO  m020
                        ;  vPrint ("\r\n  ");
m022    MOVLW .16
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  bTmp = 49;
        MOVLW .49
        MOVWF bTmp
                        ;  do
                        ;    vPut ('-');
m023    MOVLW .45
        CALL  vPut
                        ;  while (--bTmp);
        DECFSZ bTmp,1
        GOTO  m023
                        ;  vPrint ("\r\n\r\nTX Probability (U): 0x");
        MOVLW .172
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  vPutHexByte (bReadEE (eaTXPROB+1)); // show MSByte first
        MOVLW .53
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaTXPROB));
        MOVLW .52
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPrint (" out of 0xFFFF");
        MOVLW .199
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  vPrint ("\r\nGPS Baud Rate Code (V): 0x");
        MOVLW .214
        MOVWF p
        CLRF  p+1
        CALL  vPrint
                        ;  bTmp = bReadEE (eaGPSBAUDCODE);
        MOVLW .51
        CALL  bReadEE
        MOVWF bTmp
                        ;  vPutHexByte (bTmp);
        CALL  vPutHexByte
                        ;  vPut (32);
        MOVLW .32
        CALL  vPut
                        ;  vPut ('(');
        MOVLW .40
        CALL  vPut
                        ;  switch (bTmp)
        MOVF  bTmp,W
        BTFSC 0x03,Zero_
        GOTO  m024
        XORLW .1
        BTFSC 0x03,Zero_
        GOTO  m025
        XORLW .3
        BTFSC 0x03,Zero_
        GOTO  m026
        XORLW .1
        BTFSC 0x03,Zero_
        GOTO  m027
        XORLW .7
        BTFSC 0x03,Zero_
        GOTO  m028
        GOTO  m027
                        ;  {
                        ;    case 0: vPrint ("1200");  break;
m024    MOVLW .243
        MOVWF p
        CLRF  p+1
        CALL  vPrint
        GOTO  m029
                        ;    case 1: vPrint ("2400");  break;
m025    MOVLW .248
        MOVWF p
        CLRF  p+1
        CALL  vPrint
        GOTO  m029
                        ;    case 2: vPrint ("4800");  break;
m026    MOVLW .253
        MOVWF p
        CLRF  p+1
        CALL  vPrint
        GOTO  m029
                        ;    default:
                        ;    case 3: vPrint ("9600");  break;
m027    MOVLW .2
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
        GOTO  m029
                        ;    case 4: vPrint ("19200"); break;
m028    MOVLW .7
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  }
                        ;  vPrint (")\r\nBaud Cal (W): 0x");
m029    MOVLW .13
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  vPutHexByte (bReadEE (eaBAUDCAL+1)); // show MSByte first
        MOVLW .55
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPutHexByte (bReadEE (eaBAUDCAL));
        MOVLW .54
        CALL  bReadEE
        CALL  vPutHexByte
                        ;  vPrint ("\r\n\r\n");
        MOVLW .33
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  bTmp = 60;
        MOVLW .60
        MOVWF bTmp
                        ;  do
                        ;    vPut ('=');
m030    MOVLW .61
        CALL  vPut
                        ;  while (--bTmp);
        DECFSZ bTmp,1
        GOTO  m030
                        ;  vPrint ("\r\n");
        MOVLW .35
        MOVWF p
        MOVLW .1
        MOVWF p+1
        GOTO  vPrint
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Programming mode
                        ; *
                        ; *      To unlock the programming mode, enter four '+' characters (++++)
                        ; *      within 5 seconds after PIC reset. New data can be downloaded after
                        ; *      the welcome message:
                        ; *
                        ; *      Format (ASCII):
                        ; *        P <DDS phase increment for symbol 0 (8 hex digits)>
                        ; *        Q <unsigned DDS phase increment offset for symbol 1 (4 hex digits)>
                        ; *        R <unsigned DDS phase increment offset for symbol 2 (4 hex digits)>
                        ; *        S <unsigned DDS phase increment offset for symbol 3 (4 hex digits)>
                        ; *        T <162 message symbol digits, 0..3>
                        ; *        U <TX probability, 0000..FFFF => 0..100% (4 hex digits)>
                        ; *        V <GPS port baud rate code digit 0..4 (1200..19200 baud)>
                        ; *        W <signed symbol time calibration, Tcy/symbol (4 hex digits)>
                        ; *
                        ; *        X = Save all entered data to EEPROM and start the beacon
                        ; *
                        ; *      Example:
                        ; *        ------------------------
                        ; *        p 03A75614 <cr><lf>
                        ; *        q 0041 <cr><lf>
                        ; *        r 0082 <cr><lf>
                        ; *        s 00C3 <cr><lf>
                        ; *        t 01023023010231023010231023012301...(162 digits) <cr><lf>
                        ; *        u 4000 <cr><lf>
                        ; *        v 3 <cr><lf>
                        ; *        w FFEF (-17 => -17/921600 = -18.446us per symbol)
                        ; *        X <cr><lf>
                        ; *        ------------------------
                        ; *
                        ; *      Notes:
                        ; *        - The download data is not case sensitive
                        ; *        - All whitespace such as spaces, tabs, CR LF etc. is ignored
                        ; *        - The variables may appear in any order
                        ; *        - P, Q, R, S, T, U, V and W will terminate any entry in progress and start a new one
                        ; *        - Excess digits are ignored
                        ; *        - The hex data shall *not* have any prefix such as $, 0x etc.
                        ; *
                        ; *      Notes:
                        ; *        - TMR0 is assumed to be running on internal clock with prescaler = 256
                        ; */
                        ;
                        ;#define tTICKSPERSECOND 14  // ~14 TMR0 overflow ticks per second
                        ;
                        ;void vPrintUpdateResult (char bVarCode, bit qOkay)
                        ;{
vPrintUpdateResult
                        ;  vPrint ("\r\n");
        MOVLW .35
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  vPut (bVarCode);
        MOVF  bVarCode,W
        CALL  vPut
                        ;  if (qOkay)
        BTFSS 0x64,qOkay
        GOTO  m031
                        ;    vPrint (" updated OK");
        MOVLW .38
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  else
        GOTO  m032
                        ;    vPrint (" Failed! - EEPROM error!");
m031    MOVLW .50
        MOVWF p
        MOVLW .1
        MOVWF p+1
        GOTO  vPrint
                        ;}
m032    RETURN
                        ;
                        ;
                        ;void vPrintNotUpdated (char bVarCode)
                        ;{
vPrintNotUpdated
        MOVWF bVarCode_2
                        ;  vPrint ("\r\n");
        MOVLW .35
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  vPut (bVarCode);
        MOVF  bVarCode_2,W
        CALL  vPut
                        ;  vPrint (" NOT updated!");
        MOVLW .75
        MOVWF p
        MOVLW .1
        MOVWF p+1
        GOTO  vPrint
                        ;}
                        ;
                        ;
                        ;void vProgMode (void)
                        ;{
vProgMode
                        ;  char bTickDiv;
                        ;  char bSecondsToTimeout;
                        ;  char bState;
                        ;  char bRx;
                        ;  char bCmd;
                        ;  char bDigitCnt;
                        ;  char bShifter;
                        ;  uns32 ulP;
                        ;  uns16 wQ;
                        ;  uns16 wR;
                        ;  uns16 wS;
                        ;  char abT[41];
                        ;  uns16 wU;
                        ;  char bV;
                        ;  uns16 wW;
                        ;  bit qP_Updated;
                        ;  bit qQ_Updated;
                        ;  bit qR_Updated;
                        ;  bit qS_Updated;
                        ;  bit qT_Updated;
                        ;  bit qU_Updated;
                        ;  bit qV_Updated;
                        ;  bit qW_Updated;
                        ;  bit qBurnOk;
                        ;
                        ;  // Initialize the UART for 9600 baud 8N1
                        ;
                        ;  SPBRG = 5;                          // 9600 baud with BRGH=0 and Fxtal=3.6864MHz
        MOVLW .5
        MOVWF SPBRG
                        ;  TXSTA = 0b00100000;                 // 8-bit TX, TX on, asynch, BRGH=0 (low speed)
        MOVLW .32
        MOVWF TXSTA
                        ;  RCSTA = 0b10010000;                 // UART on, 8-bit RX, continous RX, address detect off
        MOVLW .144
        BCF   0x03,RP0
        MOVWF RCSTA
                        ;
                        ;  vPrint ("\r\n\r\nMJB v002\r\n\r\nCurrent Settings:\r\n");
        MOVLW .89
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;  vDumpSettings ();
        CALL  vDumpSettings
                        ;  vPrint ("\r\nEnter ++++ for cmd mode...");
        MOVLW .125
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;
                        ;  oGLEDn = 0;                         // green LED on
        BCF   PORTA,4
                        ;  bState = 0;                         // state 0 => look for "++++" within 5 seconds
        CLRF  bState
                        ;  bDigitCnt = 0;                      // no characters received yet
        CLRF  bDigitCnt
                        ;  bTickDiv = tTICKSPERSECOND;         // load full second
        MOVLW .14
        MOVWF bTickDiv
                        ;  bSecondsToTimeout = 5;              // initial timeout ~5s (for entering ++++)
        MOVLW .5
        MOVWF bSecondsToTimeout
                        ;
                        ;  for (;;)                            // stay in this loop until "WRITE" command or any timeout
                        ;  {
                        ;    clrwdt ();                        // feed the watchdog
m033    CLRWDT
                        ;
                        ;    // Run timeout timer
                        ;
                        ;    if (T0IF)                         // TMR0 tick?
        BTFSS 0x0B,T0IF
        GOTO  m034
                        ;    {
                        ;      T0IF = 0;                       // yes, clear overflow flag
        BCF   0x0B,T0IF
                        ;      if (--bTickDiv == 0)            // full second?
        DECFSZ bTickDiv,1
        GOTO  m034
                        ;      {
                        ;        bTickDiv = tTICKSPERSECOND;   // yes!
        MOVLW .14
        MOVWF bTickDiv
                        ;        if (--bSecondsToTimeout == 0) // timeout yet?
        DECFSZ bSecondsToTimeout,1
        GOTO  m034
                        ;        {
                        ;          LEDSOFF_KEYOFF_FSKZERO      // LEDs off, key = 0, FSK output = 0
        MOVLW .24
        MOVWF PORTA
                        ;//          oRLEDn = 1;                 // blow out the LEDs
                        ;//          oGLEDn = 1;
                        ;//          oTX_KEY = 0;                // turn off VCXO TX, if on
                        ;          vPrint ("\r\nStarting beacon...\r\n");
        MOVLW .174
        MOVWF p
        MOVLW .1
        MOVWF p+1
        GOTO  vPrint
                        ;          return;                     // yes, give up, go start the beacon
                        ;        }
                        ;      }
                        ;    }
                        ;
                        ;    if (!RCIF)                        // any character received by UART?
m034    BTFSS 0x0C,RCIF
                        ;      continue;                       // no, keep on waiting, back to top of loop
        GOTO  m033
                        ;
                        ;    if (RCSTA & 0x06)                 // yes, overrun or framing error?
        MOVLW .6
        ANDWF RCSTA,W
        BTFSC 0x03,Zero_
        GOTO  m035
                        ;    {
                        ;      W = RCREG;                      // yes, just flush the UART's FIFO and...
        MOVF  RCREG,W
                        ;      W = RCREG;
        MOVF  RCREG,W
                        ;      CREN = 0;                       // ...reset the UART (ignore the error...)
        BCF   0x18,CREN
                        ;      CREN = 1;
        BSF   0x18,CREN
                        ;      continue;                       // keep on waiting, back to top of loop
        GOTO  m033
                        ;    }
                        ;
                        ;    bRx = RCREG;                      // pick the received character from the UART
m035    MOVF  RCREG,W
        MOVWF bRx
                        ;
                        ;    if (bState == 0)                  // still waiting for unlock string? (++++)
        MOVF  bState,1
        BTFSS 0x03,Zero_
        GOTO  m037
                        ;    {
                        ;      if (bRx == '+')                 // '+' received?
        XORLW .43
        BTFSS 0x03,Zero_
        GOTO  m036
                        ;      {
                        ;        bDigitCnt++;                  // yes, count it
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.2)              // 4 consecutive '+' received?
        BTFSS bDigitCnt,2
        GOTO  m033
                        ;        {
                        ;          bSecondsToTimeout = 60;     // ~1 minute timeout after unlock
        MOVLW .60
        MOVWF bSecondsToTimeout
                        ;          oRLEDn = 0;                 // unlocked! red LED on
        BCF   PORTA,3
                        ;          bState = 1;                 // switch to idle state
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      else                            // it was another character (not '+')
        GOTO  m033
                        ;        bDigitCnt = 0;                // start counting from scratch
m036    CLRF  bDigitCnt
                        ;      continue;                       // go wait for the next character
        GOTO  m033
                        ;    }
                        ;
                        ;    // Command characters L, M, N and O just key the TX and change the FSK outputs.
                        ;    // Command characters P, Q, R, S, T, U, V and W have priority and will force
                        ;    // the simple state machine to begin receiving a new value at any time.
                        ;    // Command character X is the "save to EEPROM and exit" command.
                        ;
                        ;    if ((bRx >= 'a') && (bRx <= 'z')) // convert lower case letters to upper case
m037    MOVLW .97
        SUBWF bRx,W
        BTFSS 0x03,Carry
        GOTO  m038
        MOVLW .123
        SUBWF bRx,W
        BTFSC 0x03,Carry
        GOTO  m038
                        ;      bRx -= 0x20;
        MOVLW .32
        SUBWF bRx,1
                        ;
                        ;    bCmd = bRx - 'L';                 // bRx = 'L'..'X' => bCmd = 0..12
m038    MOVLW .76
        SUBWF bRx,W
        MOVWF bCmd
                        ;    if (bCmd <= 12)                   // valid command character?
        MOVLW .13
        SUBWF bCmd,W
        BTFSC 0x03,Carry
        GOTO  m067
                        ;    {
                        ;      bSecondsToTimeout = 60;         // yes, valid command started, reload timeout
        MOVLW .60
        MOVWF bSecondsToTimeout
                        ;      bDigitCnt = 0;                  // no digits received yet for this command
        CLRF  bDigitCnt
                        ;
                        ;      skip (bCmd);                    // jump table is faster/smaller than a switch()
        MOVLW .3
        MOVWF PCLATH
        MOVF  bCmd,W
        ADDWF PCL,1
                        ;      goto cmd0;                      // L => TX FSK symbol 0 (for VCXO adjustment)
        GOTO  m039
                        ;      goto cmd1;                      // M => TX FSK symbol 1 (for VCXO adjustment)
        GOTO  m039
                        ;      goto cmd2;                      // N => TX FSK symbol 2 (for VCXO adjustment)
        GOTO  m039
                        ;      goto cmd3;                      // O => TX FSK symbol 3 (for VCXO adjustment)
        GOTO  m039
                        ;      goto cmd4;                      // P => set DDS base phase increment
        GOTO  m040
                        ;      goto cmd5;                      // Q => set DDS symbol 1 phase increment offset
        GOTO  m041
                        ;      goto cmd6;                      // R => set DDS symbol 2 phase increment offset
        GOTO  m042
                        ;      goto cmd7;                      // S => set DDS symbol 3 phase increment offset
        GOTO  m043
                        ;      goto cmd8;                      // T => set beacon message
        GOTO  m044
                        ;      goto cmd9;                      // U => set TX probability
        GOTO  m045
                        ;      goto cmd10;                     // V => set GPS baud rate
        GOTO  m046
                        ;      goto cmd11;                     // W => set MEPT_JT baud rate calibration value
        GOTO  m047
                        ;      goto cmd12;                     // X => save all updated settings to EEPROM and exit
        GOTO  m048
                        ;
                        ;#pragma computedGoto 0
                        ;
                        ;cmd0: // *#* WARNING: Ugly hardcoded access to FSK pins in PORTA!
                        ;cmd1: // bCmd == wanted symbol code and FSK outputs D1:D0 happens
                        ;cmd2: // to be on PORTA pins 1:0 so we save some code space by doing it the simple way:
                        ;cmd3:
                        ;      PORTA = (PORTA & 0b11111100) | bCmd;  // set FSK output to wanted symbol number
m039    MOVLW .252
        ANDWF PORTA,W
        IORWF bCmd,W
        MOVWF PORTA
                        ;      oTX_KEY = 1;                    // turn on VCXO TX
        BSF   PORTA,2
                        ;      bSecondsToTimeout = 0;          // VCXO adjustment may take some time, 0 => 256 seconds timeout
        CLRF  bSecondsToTimeout
                        ;      continue;                       // stay in command receiving state (1)
        GOTO  m033
                        ;cmd4:
                        ;      qP_Updated = FALSE;             // flag this variable as "not updated" (yet)
m040    BCF   0x61,qP_Updated
                        ;      bState = 2;                     // start picking digits for P
        MOVLW .2
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd5:
                        ;      qQ_Updated = FALSE;
m041    BCF   0x61,qQ_Updated
                        ;      bState = 3;                     // start picking digits for Q
        MOVLW .3
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd6:
                        ;      qR_Updated = FALSE;
m042    BCF   0x61,qR_Updated
                        ;      bState = 4;                     // start picking digits for R
        MOVLW .4
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd7:
                        ;      qS_Updated = FALSE;
m043    BCF   0x61,qS_Updated
                        ;      bState = 5;                     // start picking digits for S
        MOVLW .5
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd8:
                        ;      qT_Updated = FALSE;
m044    BCF   0x61,qT_Updated
                        ;      bState = 6;                     // start picking digits for T
        MOVLW .6
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd9:
                        ;      qU_Updated = FALSE;
m045    BCF   0x61,qU_Updated
                        ;      bState = 7;                     // start picking digits for U
        MOVLW .7
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd10:
                        ;      qV_Updated = FALSE;
m046    BCF   0x61,qV_Updated
                        ;      bState = 8;                     // pick a digit for V
        MOVLW .8
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd11:
                        ;      qW_Updated = FALSE;
m047    BCF   0x61,qW_Updated
                        ;      bState = 9;                     // start picking digits for W
        MOVLW .9
        MOVWF bState
                        ;      continue;
        GOTO  m033
                        ;cmd12:
                        ;      vPut (13);
m048    MOVLW .13
        CALL  vPut
                        ;      vPut (10);
        MOVLW .10
        CALL  vPut
                        ;      if (qP_Updated)                 // P value updated OK?
        BTFSS 0x61,qP_Updated
        GOTO  m049
                        ;      {
                        ;        qBurnOk = qWriteEE (eaBASEPHINC, ulP.low8);   // yes, copy from buffer to EEPROM
        MOVLW .41
        MOVWF bAddr
        MOVF  ulP,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaBASEPHINC+1, ulP.midL8);
        MOVLW .42
        MOVWF bAddr
        MOVF  ulP+1,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaBASEPHINC+2, ulP.midH8);
        MOVLW .43
        MOVWF bAddr
        MOVF  ulP+2,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaBASEPHINC+3, ulP.high8);
        MOVLW .44
        MOVWF bAddr
        MOVF  ulP+3,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('P', qBurnOk);
        MOVLW .80
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m050
                        ;        vPrintNotUpdated ('P');
m049    MOVLW .80
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qQ_Updated)
m050    BTFSS 0x61,qQ_Updated
        GOTO  m051
                        ;      {
                        ;        qBurnOk = qWriteEE (eaFSKOFFSETS+0, wQ.low8);
        MOVLW .45
        MOVWF bAddr
        MOVF  wQ,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaFSKOFFSETS+1, wQ.high8);
        MOVLW .46
        MOVWF bAddr
        MOVF  wQ+1,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('Q', qBurnOk);
        MOVLW .81
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m052
                        ;        vPrintNotUpdated ('Q');
m051    MOVLW .81
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qR_Updated)
m052    BTFSS 0x61,qR_Updated
        GOTO  m053
                        ;      {
                        ;        qBurnOk = qWriteEE (eaFSKOFFSETS+2, wR.low8);
        MOVLW .47
        MOVWF bAddr
        MOVF  wR,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaFSKOFFSETS+3, wR.high8);
        MOVLW .48
        MOVWF bAddr
        MOVF  wR+1,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('R', qBurnOk);
        MOVLW .82
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m054
                        ;        vPrintNotUpdated ('R');
m053    MOVLW .82
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qS_Updated)
m054    BTFSS 0x61,qS_Updated
        GOTO  m055
                        ;      {
                        ;        qBurnOk = qWriteEE (eaFSKOFFSETS+4, wS.low8);
        MOVLW .49
        MOVWF bAddr
        MOVF  wS,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaFSKOFFSETS+5, wS.high8);
        MOVLW .50
        MOVWF bAddr
        MOVF  wS+1,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('S', qBurnOk);
        MOVLW .83
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m056
                        ;        vPrintNotUpdated ('S');
m055    MOVLW .83
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qT_Updated)
m056    BTFSS 0x61,qT_Updated
        GOTO  m059
                        ;      {
                        ;        qBurnOk = TRUE;
        BSF   0x62,qBurnOk
                        ;        for (bDigitCnt = 0; bDigitCnt < sizeof(abT); bDigitCnt++)
        CLRF  bDigitCnt
m057    MOVLW .41
        SUBWF bDigitCnt,W
        BTFSC 0x03,Carry
        GOTO  m058
                        ;          qBurnOk &= qWriteEE (eaSYMBOLTABLE+bDigitCnt, abT[bDigitCnt]);
        MOVF  bDigitCnt,W
        MOVWF bAddr
        MOVLW .51
        ADDWF bDigitCnt,W
        MOVWF FSR
        BCF   0x03,IRP
        MOVF  INDF,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
        INCF  bDigitCnt,1
        GOTO  m057
                        ;        vPrintUpdateResult ('T', qBurnOk);
m058    MOVLW .84
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m060
                        ;        vPrintNotUpdated ('T');
m059    MOVLW .84
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qU_Updated)
m060    BTFSS 0x61,qU_Updated
        GOTO  m061
                        ;      {
                        ;        qBurnOk = qWriteEE (eaTXPROB+0, wU.low8);
        MOVLW .52
        MOVWF bAddr
        MOVF  wU,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaTXPROB+1, wU.high8);
        MOVLW .53
        MOVWF bAddr
        MOVF  wU+1,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('U', qBurnOk);
        MOVLW .85
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m062
                        ;        vPrintNotUpdated ('U');
m061    MOVLW .85
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qV_Updated)
m062    BTFSS 0x61,qV_Updated
        GOTO  m063
                        ;      {
                        ;        qBurnOk = qWriteEE (eaGPSBAUDCODE, bV);
        MOVLW .51
        MOVWF bAddr
        MOVF  bV,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('V', qBurnOk);
        MOVLW .86
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m064
                        ;        vPrintNotUpdated ('V');
m063    MOVLW .86
        CALL  vPrintNotUpdated
                        ;
                        ;      if (qW_Updated)
m064    BTFSS 0x61,qW_Updated
        GOTO  m065
                        ;      {
                        ;        qBurnOk = qWriteEE (eaBAUDCAL+0, wW.low8);
        MOVLW .54
        MOVWF bAddr
        MOVF  wW,W
        CALL  qWriteEE
        BCF   0x62,qBurnOk
        BTFSC 0x03,Carry
        BSF   0x62,qBurnOk
                        ;        qBurnOk &= qWriteEE (eaBAUDCAL+1, wW.high8);
        MOVLW .55
        MOVWF bAddr
        MOVF  wW+1,W
        CALL  qWriteEE
        BTFSS 0x03,Carry
        BCF   0x62,qBurnOk
                        ;        vPrintUpdateResult ('W', qBurnOk);
        MOVLW .87
        MOVWF bVarCode
        BCF   0x64,qOkay
        BTFSC 0x62,qBurnOk
        BSF   0x64,qOkay
        CALL  vPrintUpdateResult
                        ;      }
                        ;      else
        GOTO  m066
                        ;        vPrintNotUpdated ('W');
m065    MOVLW .87
        CALL  vPrintNotUpdated
                        ;
                        ;      vPrint ("\r\n\r\nNew Settings:\r\n");
m066    MOVLW .154
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;      vDumpSettings ();             // show new settings as stored in EEPROM
        CALL  vDumpSettings
                        ;      vPrint ("\r\nStarting beacon...\r\n");
        MOVLW .174
        MOVWF p
        MOVLW .1
        MOVWF p+1
        CALL  vPrint
                        ;      LEDSOFF_KEYOFF_FSKZERO        // LEDs off, key = 0, FSK output = 0
        MOVLW .24
        MOVWF PORTA
                        ;//      oRLEDn = 1;                   // blow out the red LED
                        ;//      oGLEDn = 1;                   // blow out the green LED
                        ;//      oTX_KEY = 0;                  // turn off VCXO TX, if on
                        ;      return;
        RETURN
                        ;    }
                        ;
                        ;    if (bState == 1)                  // character other than PQRSTUV in idle state?
m067    DECF  bState,W
        BTFSC 0x03,Zero_
                        ;      continue;                       // yes, simply ignore it
        GOTO  m033
                        ;
                        ;    // If valid hex digit, convert it to a 0..15 nibble, else ignore the character
                        ;
                        ;    if ((bRx >= '0') && (bRx <= '9'))
        MOVLW .48
        SUBWF bRx,W
        BTFSS 0x03,Carry
        GOTO  m068
        MOVLW .58
        SUBWF bRx,W
        BTFSC 0x03,Carry
        GOTO  m068
                        ;      bRx -= '0';
        MOVLW .48
        SUBWF bRx,1
                        ;    else
        GOTO  m069
                        ;    if ((bRx >= 'A') && (bRx <= 'F'))
m068    MOVLW .65
        SUBWF bRx,W
        BTFSS 0x03,Carry
        GOTO  m033
        MOVLW .71
        SUBWF bRx,W
        BTFSC 0x03,Carry
        GOTO  m033
                        ;      bRx -= ('A' - 10);
        MOVLW .55
        SUBWF bRx,1
                        ;    else                              // not a valid hex digit
                        ;      continue;                       // ignore it
                        ;
                        ;    if (bState == 2)                  // picking 8 hex digits for P?
m069    MOVF  bState,W
        XORLW .2
        BTFSS 0x03,Zero_
        GOTO  m071
                        ;    {
                        ;      if ((bDigitCnt & 0b11111000) == 0)  // < 8 digits entered so far?
        MOVLW .248
        ANDWF bDigitCnt,W
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        ulP <<= 4;                    // yes, make room for next nibble in LSByte
        MOVLW .4
        MOVWF C2cnt
m070    BCF   0x03,Carry
        RLF   ulP,1
        RLF   ulP+1,1
        RLF   ulP+2,1
        RLF   ulP+3,1
        DECFSZ C2cnt,1
        GOTO  m070
                        ;        ulP.low8 |= bRx;              // squeeze in the new nibble
        MOVF  bRx,W
        IORWF ulP,1
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.3)              // 8 digits entered? (bit 3 == 1?)
        BTFSS bDigitCnt,3
        GOTO  m033
                        ;        {
                        ;          qP_Updated = TRUE;          // yes, P fully entered
        BSF   0x61,qP_Updated
                        ;          bState = 1;                 // done with P
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 3)                  // picking 4 hex digits for Q?
m071    MOVF  bState,W
        XORLW .3
        BTFSS 0x03,Zero_
        GOTO  m073
                        ;    {
                        ;      if ((bDigitCnt & 0b11111100) == 0)  // < 4 digits entered so far?
        MOVLW .252
        ANDWF bDigitCnt,W
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        wQ <<= 4;                     // yes, make room for next nibble in LSByte
        MOVLW .4
        MOVWF C3cnt
m072    BCF   0x03,Carry
        RLF   wQ,1
        RLF   wQ+1,1
        DECFSZ C3cnt,1
        GOTO  m072
                        ;        wQ.low8 |= bRx;               // squeeze in the new nibble
        MOVF  bRx,W
        IORWF wQ,1
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.2)              // 4 digits entered? (bit 2 == 1?)
        BTFSS bDigitCnt,2
        GOTO  m033
                        ;        {
                        ;          qQ_Updated = TRUE;          // yes
        BSF   0x61,qQ_Updated
                        ;          bState = 1;                 // done with Q
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 4)                  // picking 4 hex digits for R?
m073    MOVF  bState,W
        XORLW .4
        BTFSS 0x03,Zero_
        GOTO  m075
                        ;    {
                        ;      if ((bDigitCnt & 0b11111100) == 0)  // < 4 digits entered so far?
        MOVLW .252
        ANDWF bDigitCnt,W
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        wR <<= 4;                     // yes, make room for next nibble in LSByte
        MOVLW .4
        MOVWF C4cnt
m074    BCF   0x03,Carry
        RLF   wR,1
        RLF   wR+1,1
        DECFSZ C4cnt,1
        GOTO  m074
                        ;        wR.low8 |= bRx;               // squeeze in the new nibble
        MOVF  bRx,W
        IORWF wR,1
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.2)              // 4 digits entered? (bit 2 == 1?)
        BTFSS bDigitCnt,2
        GOTO  m033
                        ;        {
                        ;          qR_Updated = TRUE;          // yes
        BSF   0x61,qR_Updated
                        ;          bState = 1;                 // done with R
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 5)                  // picking 4 hex digits for S?
m075    MOVF  bState,W
        XORLW .5
        BTFSS 0x03,Zero_
        GOTO  m077
                        ;    {
                        ;      if ((bDigitCnt & 0b11111100) == 0)  // < 4 digits entered so far?
        MOVLW .252
        ANDWF bDigitCnt,W
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        wS <<= 4;                     // yes, make room for next nibble in LSByte
        MOVLW .4
        MOVWF C5cnt
m076    BCF   0x03,Carry
        RLF   wS,1
        RLF   wS+1,1
        DECFSZ C5cnt,1
        GOTO  m076
                        ;        wS.low8 |= bRx;               // squeeze in the new nibble
        MOVF  bRx,W
        IORWF wS,1
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.2)              // 4 digits entered? (bit 2 == 1?)
        BTFSS bDigitCnt,2
        GOTO  m033
                        ;        {
                        ;          qS_Updated = TRUE;          // yes
        BSF   0x61,qS_Updated
                        ;          bState = 1;                 // done with S
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 6)                  // picking 162 0/1/2/3 digits for T?
m077    MOVF  bState,W
        XORLW .6
        BTFSS 0x03,Zero_
        GOTO  m081
                        ;    {
                        ;      if (bDigitCnt < 162)            // no digit entered yet?
        MOVLW .162
        SUBWF bDigitCnt,W
        BTFSC 0x03,Carry
        GOTO  m033
                        ;      {
                        ;        if (bRx & 0b11111100)         // invalid symbol code? (bRx > 3?)
        MOVLW .252
        ANDWF bRx,W
        BTFSC 0x03,Zero_
        GOTO  m078
                        ;        {
                        ;          bState = 1;                 // yes, ignore this command
        MOVLW .1
        MOVWF bState
                        ;          continue;
        GOTO  m033
                        ;        }
                        ;
                        ;        bShifter >>= 2;               // make room for this 2-bit symbol in the shift register
m078    BCF   0x03,Carry
        RRF   bShifter,1
        BCF   0x03,Carry
        RRF   bShifter,1
                        ;        if (bRx.1)                    // put the new symbol in the two MSBits
        BTFSC bRx,1
                        ;          bShifter.7 = 1;
        BSF   bShifter,7
                        ;        if (bRx.0)
        BTFSC bRx,0
                        ;          bShifter.6 = 1;
        BSF   bShifter,6
                        ;
                        ;
                        ;        if (bDigitCnt == 161)         // last symbol?
        MOVF  bDigitCnt,W
        XORLW .161
        BTFSS 0x03,Zero_
        GOTO  m079
                        ;        {
                        ;          bShifter = swap (bShifter); // yes, move the two last symbols into LSNibble
        SWAPF bShifter,1
                        ;          bDigitCnt += 2;             // simulate "whole byte filled", 163 == 0xA3
        MOVLW .2
        ADDWF bDigitCnt,1
                        ;          qT_Updated = TRUE;
        BSF   0x61,qT_Updated
                        ;          bState = 1;                 // done with T
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;
                        ;        if ((bDigitCnt & 0x03) == 3)  // whole byte filled (4 symbols) or last symbol (bDigitCnt == 0xA3)?
m079    MOVLW .3
        ANDWF bDigitCnt,W
        XORLW .3
        BTFSS 0x03,Zero_
        GOTO  m080
                        ;        {
                        ;          bRx = bDigitCnt >> 2;       // find array index (bRx used as a temp variable here)
        BCF   0x03,Carry
        RRF   bDigitCnt,W
        MOVWF bRx
        BCF   0x03,Carry
        RRF   bRx,1
                        ;          abT[bRx] = bShifter;        // save the 4 symbols
        MOVLW .51
        ADDWF bRx,W
        MOVWF FSR
        BCF   0x03,IRP
        MOVF  bShifter,W
        MOVWF INDF
                        ;        }
                        ;
                        ;        bDigitCnt++;                  // count the symbol
m080    INCF  bDigitCnt,1
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 7)                  // picking 4 hex digits for U?
m081    MOVF  bState,W
        XORLW .7
        BTFSS 0x03,Zero_
        GOTO  m083
                        ;    {
                        ;      if ((bDigitCnt & 0b11111100) == 0)  // < 4 digits entered so far?
        MOVLW .252
        ANDWF bDigitCnt,W
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        wU <<= 4;                     // yes, make room for next nibble in LSByte
        MOVLW .4
        MOVWF C6cnt
m082    BCF   0x03,Carry
        RLF   wU,1
        RLF   wU+1,1
        DECFSZ C6cnt,1
        GOTO  m082
                        ;        wU.low8 |= bRx;               // squeeze in the new nibble
        MOVF  bRx,W
        IORWF wU,1
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.2)              // 4 digits entered? (bit 2 == 1?)
        BTFSS bDigitCnt,2
        GOTO  m033
                        ;        {
                        ;          qU_Updated = TRUE;          // yes
        BSF   0x61,qU_Updated
                        ;          bState = 1;                 // done with U
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 8)                  // picking 1 digit for V?
m083    MOVF  bState,W
        XORLW .8
        BTFSS 0x03,Zero_
        GOTO  m085
                        ;    {
                        ;      if (bDigitCnt == 0)             // no digit entered yet?
        MOVF  bDigitCnt,1
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        if (bRx > 4)                  // invalid baud rate code?
        MOVLW .5
        SUBWF bRx,W
        BTFSS 0x03,Carry
        GOTO  m084
                        ;        {
                        ;          bState = 1;                 // yes, ignore this command
        MOVLW .1
        MOVWF bState
                        ;          continue;
        GOTO  m033
                        ;        }
                        ;        bV = bRx;                     // code OK, save it
m084    MOVF  bRx,W
        MOVWF bV
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        qV_Updated = TRUE;
        BSF   0x61,qV_Updated
                        ;        bState = 1;                   // done with V
        MOVLW .1
        MOVWF bState
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;
                        ;    if (bState == 9)                  // picking 4 hex digits for W?
m085    MOVF  bState,W
        XORLW .9
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;    {
                        ;      if ((bDigitCnt & 0b11111100) == 0)  // < 4 digits entered so far?
        MOVLW .252
        ANDWF bDigitCnt,W
        BTFSS 0x03,Zero_
        GOTO  m033
                        ;      {
                        ;        wW <<= 4;                     // yes, make room for next nibble in LSByte
        MOVLW .4
        MOVWF C7cnt
m086    BCF   0x03,Carry
        RLF   wW,1
        RLF   wW+1,1
        DECFSZ C7cnt,1
        GOTO  m086
                        ;        wW.low8 |= bRx;               // squeeze in the new nibble
        MOVF  bRx,W
        IORWF wW,1
                        ;        bDigitCnt++;                  // count this digit
        INCF  bDigitCnt,1
                        ;        if (bDigitCnt.2)              // 4 digits entered? (bit 2 == 1?)
        BTFSS bDigitCnt,2
        GOTO  m033
                        ;        {
                        ;          qW_Updated = TRUE;          // yes
        BSF   0x61,qW_Updated
                        ;          bState = 1;                 // done with W
        MOVLW .1
        MOVWF bState
                        ;        }
                        ;      }
                        ;      continue;
        GOTO  m033
                        ;    }
                        ;  }
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Load new frequency into the AD9850 DDS chip
                        ; *      (BUT DO NOT STROBE IT YET!!!)
                        ; *
                        ; *      Argument:
                        ; *        ulNewPhaseIncrement = 32-bit phase increment for DDS
                        ; *        Fout = Fclk_dds * ulNewPhaseIncrement / 2^32
                        ; */
                        ;
                        ;void vPrepareDdsForQsyTo (uns32 ulNewPhaseIncrement)
                        ;{
vPrepareDdsForQsyTo
                        ;  char bLoop;
                        ;
                        ;  // Download 32-bit phase increment word to the DDS chip
                        ;
                        ;  bLoop = 32;
        MOVLW .32
        MOVWF bLoop
                        ;  do
                        ;  {
                        ;    oDDS_SDATAn = !ulNewPhaseIncrement.0; // shift out data LSBit first (inverted!)
m087    BTFSS ulNewPhaseIncrement,0
        BSF   PORTB,7
        BTFSC ulNewPhaseIncrement,0
        BCF   PORTB,7
                        ;    oDDS_SCLKn = 0;                       // make clock pulse on AD9850 W_CLK pin
        BCF   PORTB,6
                        ;    oDDS_SCLKn = 1;
        BSF   PORTB,6
                        ;    ulNewPhaseIncrement = rr (ulNewPhaseIncrement); // shift data bits to the left
        RRF   ulNewPhaseIncrement+3,1
        RRF   ulNewPhaseIncrement+2,1
        RRF   ulNewPhaseIncrement+1,1
        RRF   ulNewPhaseIncrement,1
                        ;  } while (--bLoop);                      // all 32 bits transmitted?
        DECFSZ bLoop,1
        GOTO  m087
                        ;
                        ;  // Download 8 control & phase bits (not used, send 0x00)
                        ;
                        ;  bLoop = 8;
        MOVLW .8
        MOVWF bLoop
                        ;  oDDS_SDATAn = 1;                        // inverted zero...
        BSF   PORTB,7
                        ;  do
                        ;  {
                        ;    oDDS_SCLKn = 0;                       // make clock pulse on AD9850 W_CLK pin
m088    BCF   PORTB,6
                        ;    oDDS_SCLKn = 1;
        BSF   PORTB,6
                        ;  } while (--bLoop);                      // all 8 bits transmitted?
        DECFSZ bLoop,1
        GOTO  m088
                        ;
                        ;  // The new frequency is now loaded - just pulse oDDS_STROBEn --_-- to QSY
                        ;}
        RETURN
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Initialize the AD9850 DDS chip
                        ; */
                        ;
                        ;void vInitDdsChip (void)
                        ;{
vInitDdsChip
                        ;  oDDS_RESETn = 0;                // reset the AD9850
        BCF   PORTB,4
                        ;  oDDS_RESETn = 1;
        BSF   PORTB,4
                        ;  oDDS_SCLKn = 0;                 // make W_CLK pulse to enter serial mode
        BCF   PORTB,6
                        ;  oDDS_SCLKn = 1;
        BSF   PORTB,6
                        ;  oDDS_STROBEn = 0;               // make FQ-UD pulse
        BCF   PORTB,5
                        ;  oDDS_STROBEn = 1;
        BSF   PORTB,5
                        ;  vPrepareDdsForQsyTo (0);        // zero Hz = DC = output OFF
        CLRF  ulNewPhaseIncrement
        CLRF  ulNewPhaseIncrement+1
        CLRF  ulNewPhaseIncrement+2
        CLRF  ulNewPhaseIncrement+3
        CALL  vPrepareDdsForQsyTo
                        ;  oDDS_STROBEn = 0;
        BCF   PORTB,5
                        ;  oDDS_STROBEn = 1;               // done
        BSF   PORTB,5
                        ;}
        RETURN
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Prepare for next symbol transition
                        ; *
                        ; *      Argument:
                        ; *        bSym = symbol, 0..3
                        ; *
                        ; *      Output:
                        ; *        The two symbol bits are copied to the corresponding hardware
                        ; *        port bit positions in jIsrGlobals.bNextVcxoSymbol. The tick
                        ; *        ISR will then write these bits to the VCXO port at the next
                        ; *        symbol transition.
                        ; *
                        ; *        The DDS phase increment corresponding to the symbol is computed
                        ; *        and downloaded to the DDS hardware. The actual frequency shift,
                        ; *        if any, will be occur when the tick ISR strobes the DDS chip at
                        ; *        the next "baud tick".
                        ; */
                        ;
                        ;void vEnqueueSymbol (char bSym)
                        ;{
vEnqueueSymbol
        MOVWF bSym
                        ;  uns32 ulPhInc;
                        ;  uns16 wOffset;
                        ;
                        ;  // Prepare VCXO output
                        ;
                        ;  jIsrGlobals.bNextVcxoSymbol = 0;              // assume symbol == 0
        CLRF  jIsrGlobals
                        ;  if (bSym.0)                                   // copy 1's to appropriate hardware positions
        BTFSC bSym,0
                        ;    jIsrGlobals.bNextVcxoSymbol.bnVCXO_D0 = 1;
        BSF   jIsrGlobals,0
                        ;  if (bSym.1)
        BTFSC bSym,1
                        ;    jIsrGlobals.bNextVcxoSymbol.bnVCXO_D1 = 1;
        BSF   jIsrGlobals,1
                        ;
                        ;  // Prepare DDS output
                        ;
                        ;  ulPhInc.low8 = bReadEE (eaBASEPHINC);         // read symbol 0 phase increment from EEPROM
        MOVLW .41
        CALL  bReadEE
        MOVWF ulPhInc
                        ;  ulPhInc.midL8 = bReadEE (eaBASEPHINC+1);      // this is stored LSByte first
        MOVLW .42
        CALL  bReadEE
        MOVWF ulPhInc+1
                        ;  ulPhInc.midH8 = bReadEE (eaBASEPHINC+2);
        MOVLW .43
        CALL  bReadEE
        MOVWF ulPhInc+2
                        ;  ulPhInc.high8 = bReadEE (eaBASEPHINC+3);
        MOVLW .44
        CALL  bReadEE
        MOVWF ulPhInc+3
                        ;
                        ;  if (bSym)                                     // symbol other than 0?
        MOVF  bSym,1
        BTFSC 0x03,Zero_
        GOTO  m090
                        ;  {
                        ;    bSym--;                                     // yes, it is 1, 2 or 3, make it 0, 1 or 2
        DECF  bSym,1
                        ;    bSym *= 2;                                  // 2 bytes in each offset table entry
        BCF   0x03,Carry
        RLF   bSym,1
                        ;    bSym += eaFSKOFFSETS;                       // add base address
        MOVLW .45
        ADDWF bSym,1
                        ;    wOffset.low8 = bReadEE (bSym);              // read LSByte from EEPROM
        MOVF  bSym,W
        CALL  bReadEE
        MOVWF wOffset
                        ;    bSym++;                                     // bump pointer
        INCF  bSym,1
                        ;    wOffset.high8 = bReadEE (bSym);             // read MSByte from EEPROM
        MOVF  bSym,W
        CALL  bReadEE
        MOVWF wOffset+1
                        ;    ulPhInc += wOffset;                         // now we have the phase increment for this symbol
        ADDWF ulPhInc+1,1
        BTFSS 0x03,Carry
        GOTO  m089
        INCF  ulPhInc+2,1
        BTFSC 0x03,Zero_
        INCF  ulPhInc+3,1
m089    MOVF  wOffset,W
        ADDWF ulPhInc,1
        BTFSS 0x03,Carry
        GOTO  m090
        INCFSZ ulPhInc+1,1
        GOTO  m090
        INCF  ulPhInc+2,1
        BTFSC 0x03,Zero_
        INCF  ulPhInc+3,1
                        ;  }
                        ;
                        ;  vPrepareDdsForQsyTo (ulPhInc);                // download to DDS hardware but don't QSY yet...
m090    MOVF  ulPhInc,W
        MOVWF ulNewPhaseIncrement
        MOVF  ulPhInc+1,W
        MOVWF ulNewPhaseIncrement+1
        MOVF  ulPhInc+2,W
        MOVWF ulNewPhaseIncrement+2
        MOVF  ulPhInc+3,W
        MOVWF ulNewPhaseIncrement+3
        CALL  vPrepareDdsForQsyTo
                        ;
                        ;  jIsrGlobals.qNewFreqInQueue = TRUE;           // this will be set FALSE by the ISR when it wants more
        BSF   jIsrGlobals+2,0
                        ;}
        BSF   0x03,RP0
        RETURN
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Synchronize to even UTC minute from GPS NMEA stream
                        ; *
                        ; *      This is a simple "fly-by" state machine that looks for $GPRMC and
                        ; *      $GPGGA sentences on the serial port and returns TRUE on the top of
                        ; *      even minutes (if the UTC time looks valid).
                        ; *
                        ; *      <cr-lf ignored> $GPGGA,hhmmss <rest of line ignored>
                        ; *      <cr-lf ignored> $GPRMC,hhmmss <rest of line ignored>
                        ; *
                        ; *      This function must be called at a rate faster than the serial
                        ; *      character rate.
                        ; *
                        ; *      The NMEA checksum, if present, is *not* checked (this is a hobby project after all ;-).
                        ; */
                        ;
                        ;bit qGpsEvenMinute (void)
                        ;{
qGpsEvenMinute
                        ;  static char bNmeaState;           // static => cleared to zero by clearRAM() at start-up
                        ;  static char bHour;
                        ;  static char bMinute @ bHour;      // save a byte of RAM, bMinute and bHour are never used at the same time
                        ;  static char bSecond;
                        ;  char bRx;
                        ;
                        ;  if (!RCIF)                        // any character received?
        BTFSC 0x0C,RCIF
        GOTO  m091
                        ;    return FALSE;                   // no, quit immediately
        BCF   0x03,Carry
        RETURN
                        ;
                        ;  if (RCSTA & 6)                    // UART overrun or framing error?
m091    MOVLW .6
        ANDWF RCSTA,W
        BTFSC 0x03,Zero_
        GOTO  m092
                        ;  {
                        ;    W = RCREG;                      // drain FIFO
        MOVF  RCREG,W
                        ;    W = RCREG;
        MOVF  RCREG,W
                        ;    CREN = 0;                       // reset the UART (it gets stuck after overrun error!)
        BCF   0x18,CREN
                        ;    CREN = 1;
        BSF   0x18,CREN
                        ;    return FALSE;                   // quit
        BCF   0x03,Carry
        RETURN
                        ;  }
                        ;
                        ;  bRx = RCREG;                      // pick the received character from the UART
m092    MOVF  RCREG,W
        MOVWF bRx_2
                        ;
                        ;  if (bRx == '$')                   // start character of NMEA sentence?
        XORLW .36
        BTFSS 0x03,Zero_
        GOTO  m093
                        ;  {
                        ;    bNmeaState = 1;                 // yes, start receiving the sentence from scratch
        MOVLW .1
        MOVWF bNmeaState
                        ;    return FALSE;
        BCF   0x03,Carry
        RETURN
                        ;  }
                        ;
                        ;  // NMEA receiving state machine
                        ;  // "Computed Goto" using a jump table is faster than a long switch()...
                        ;
                        ;  if (bNmeaState > 14)              // illegal state!? ("what if" paranoia)
m093    MOVLW .15
        SUBWF bNmeaState,W
        BTFSS 0x03,Carry
        GOTO  m095
                        ;    for (;;)                        // wait for watchdog reset
                        ;      GIE = 0;                      // keep interrupts disabled
m094    BCF   0x0B,GIE
        GOTO  m094
                        ;
                        ;  skip (bNmeaState);
m095    MOVLW .6
        MOVWF PCLATH
        MOVF  bNmeaState,W
        ADDWF PCL,1
                        ;  goto st0_Idle;
        GOTO  m096
                        ;  goto st1_Get_Gpxxx;
        GOTO  m097
                        ;  goto st2_Get_gPxxx;
        GOTO  m100
                        ;  goto st3_Get_gpGga_or_gpRmc;
        GOTO  m103
                        ;  goto st4_Get_gpgGa;
        GOTO  m107
                        ;  goto st5_Get_gpggA;
        GOTO  m110
                        ;  goto st6_Get_gprMc;
        GOTO  m113
                        ;  goto st7_Get_gprmC;
        GOTO  m116
                        ;  goto st8_Get_comma;
        GOTO  m119
                        ;  goto st9_Get_10h;
        GOTO  m122
                        ;  goto st10_Get_1h;
        GOTO  m125
                        ;  goto st11_Get_10m;
        GOTO  m128
                        ;  goto st12_Get_1m;
        GOTO  m131
                        ;  goto st13_Get_10s;
        GOTO  m134
                        ;  goto st14_Get_1s;
        GOTO  m137
                        ;
                        ;#pragma computedGoto 0
                        ;
                        ;st0_Idle:
                        ;  return FALSE;
m096    BCF   0x03,Carry
        RETURN
                        ;
                        ;st1_Get_Gpxxx:
                        ;  if (bRx == 'G')               // 'G' is expected here
m097    MOVF  bRx_2,W
        XORLW .71
        BTFSS 0x03,Zero_
        GOTO  m098
                        ;    bNmeaState++;               // ok, proceed to next state
        INCF  bNmeaState,1
                        ;  else                          // not the expected 'G' so...
        GOTO  m099
                        ;    bNmeaState = 0;             // ...back to square zero and wait for another '$'
m098    CLRF  bNmeaState
                        ;  return FALSE;
m099    BCF   0x03,Carry
        RETURN
                        ;
                        ;st2_Get_gPxxx:
                        ;  if (bRx == 'P')               // 'P' is expected here
m100    MOVF  bRx_2,W
        XORLW .80
        BTFSS 0x03,Zero_
        GOTO  m101
                        ;    bNmeaState++;               // ok, we've got "GP" so far
        INCF  bNmeaState,1
                        ;  else
        GOTO  m102
                        ;    bNmeaState = 0;             // sorry...
m101    CLRF  bNmeaState
                        ;  return FALSE;
m102    BCF   0x03,Carry
        RETURN
                        ;
                        ;st3_Get_gpGga_or_gpRmc:
                        ;  if (bRx == 'G')               // 'G' or 'R' is expected here
m103    MOVF  bRx_2,W
        XORLW .71
        BTFSS 0x03,Zero_
        GOTO  m104
                        ;    bNmeaState++;               // ok, we've got "GPG" so far
        INCF  bNmeaState,1
                        ;  else
        GOTO  m106
                        ;  if (bRx == 'R')
m104    MOVF  bRx_2,W
        XORLW .82
        BTFSS 0x03,Zero_
        GOTO  m105
                        ;    bNmeaState = 6;             // ok, we've got "GPR" so far
        MOVLW .6
        MOVWF bNmeaState
                        ;  else
        GOTO  m106
                        ;    bNmeaState = 0;             // sorry...
m105    CLRF  bNmeaState
                        ;  return FALSE;
m106    BCF   0x03,Carry
        RETURN
                        ;
                        ;st4_Get_gpgGa:
                        ;  if (bRx == 'G')               // 'G' is expected here
m107    MOVF  bRx_2,W
        XORLW .71
        BTFSS 0x03,Zero_
        GOTO  m108
                        ;    bNmeaState++;               // ok, we've got "GPGG" so far
        INCF  bNmeaState,1
                        ;  else
        GOTO  m109
                        ;    bNmeaState = 0;             // sorry...
m108    CLRF  bNmeaState
                        ;  return FALSE;
m109    BCF   0x03,Carry
        RETURN
                        ;
                        ;st5_Get_gpggA:
                        ;  if (bRx == 'A')               // 'A' is expected here
m110    MOVF  bRx_2,W
        XORLW .65
        BTFSS 0x03,Zero_
        GOTO  m111
                        ;    bNmeaState = 8;             // ok, we've got "GPGGA" so far
        MOVLW .8
        MOVWF bNmeaState
                        ;  else
        GOTO  m112
                        ;    bNmeaState = 0;             // sorry...
m111    CLRF  bNmeaState
                        ;  return FALSE;
m112    BCF   0x03,Carry
        RETURN
                        ;
                        ;st6_Get_gprMc:
                        ;  if (bRx == 'M')               // 'M' is expected here
m113    MOVF  bRx_2,W
        XORLW .77
        BTFSS 0x03,Zero_
        GOTO  m114
                        ;    bNmeaState++;               // ok, we've got "GPRM" so far
        INCF  bNmeaState,1
                        ;  else
        GOTO  m115
                        ;    bNmeaState = 0;             // sorry...
m114    CLRF  bNmeaState
                        ;  return FALSE;
m115    BCF   0x03,Carry
        RETURN
                        ;
                        ;st7_Get_gprmC:
                        ;  if (bRx == 'C')               // 'C' is expected here
m116    MOVF  bRx_2,W
        XORLW .67
        BTFSS 0x03,Zero_
        GOTO  m117
                        ;    bNmeaState++;               // ok, we've got "GPRMC" so far
        INCF  bNmeaState,1
                        ;  else
        GOTO  m118
                        ;    bNmeaState = 0;             // sorry...
m117    CLRF  bNmeaState
                        ;  return FALSE;
m118    BCF   0x03,Carry
        RETURN
                        ;
                        ;st8_Get_comma:
                        ;  if (bRx == ',')               // ',' is expected here
m119    MOVF  bRx_2,W
        XORLW .44
        BTFSS 0x03,Zero_
        GOTO  m120
                        ;    bNmeaState++;               // ok, we've got "GPGGA," or "GPRMC," so far
        INCF  bNmeaState,1
                        ;  else
        GOTO  m121
                        ;    bNmeaState = 0;             // sorry...
m120    CLRF  bNmeaState
                        ;  return FALSE;
m121    BCF   0x03,Carry
        RETURN
                        ;
                        ;st9_Get_10h:
                        ;  bRx -= '0';                   // hopefully the 10 hour digit, convert to binary
m122    MOVLW .48
        SUBWF bRx_2,1
                        ;  if (bRx <= '2')               // 0..2?
        MOVLW .51
        SUBWF bRx_2,W
        BTFSC 0x03,Carry
        GOTO  m123
                        ;  {
                        ;    bHour = bRx;                // yes, valid digit
        MOVF  bRx_2,W
        MOVWF bHour
                        ;    bHour <<= 3;                // multiply by 10 the fast way ;-)
        BCF   0x03,Carry
        RLF   bHour,1
        BCF   0x03,Carry
        RLF   bHour,1
        BCF   0x03,Carry
        RLF   bHour,1
                        ;    bHour += bRx;
        ADDWF bHour,1
                        ;    bHour += bRx;
        ADDWF bHour,1
                        ;    bNmeaState++;
        INCF  bNmeaState,1
                        ;  }
                        ;  else
        GOTO  m124
                        ;    bNmeaState = 0;             // sorry...
m123    CLRF  bNmeaState
                        ;  return FALSE;
m124    BCF   0x03,Carry
        RETURN
                        ;
                        ;st10_Get_1h:
                        ;  bRx -= '0';                   // hopefully the 1 hour digit, convert to binary
m125    MOVLW .48
        SUBWF bRx_2,1
                        ;  if (bRx <= '9')               // 0..9?
        MOVLW .58
        SUBWF bRx_2,W
        BTFSC 0x03,Carry
        GOTO  m126
                        ;  {
                        ;    bHour += bRx;               // yes, valid digit, add 10*10's + 1's
        MOVF  bRx_2,W
        ADDWF bHour,1
                        ;    if (bHour <= 23)            // valid hour?
        MOVLW .24
        SUBWF bHour,W
        BTFSC 0x03,Carry
        GOTO  m127
                        ;      bNmeaState++;             // OK!
        INCF  bNmeaState,1
                        ;  }
                        ;  else
        GOTO  m127
                        ;    bNmeaState = 0;             // sorry...
m126    CLRF  bNmeaState
                        ;  return FALSE;
m127    BCF   0x03,Carry
        RETURN
                        ;
                        ;st11_Get_10m:
                        ;  bRx -= '0';                   // hopefully the 10 minute digit, convert to binary
m128    MOVLW .48
        SUBWF bRx_2,1
                        ;  if (bRx <= '5')               // 0..5?
        MOVLW .54
        SUBWF bRx_2,W
        BTFSC 0x03,Carry
        GOTO  m129
                        ;  {
                        ;    bMinute = bRx;              // yes, valid digit
        MOVF  bRx_2,W
        MOVWF bMinute
                        ;    bMinute <<= 3;              // multiply by 10 the fast way ;-)
        BCF   0x03,Carry
        RLF   bMinute,1
        BCF   0x03,Carry
        RLF   bMinute,1
        BCF   0x03,Carry
        RLF   bMinute,1
                        ;    bMinute += bRx;
        ADDWF bMinute,1
                        ;    bMinute += bRx;
        ADDWF bMinute,1
                        ;    bNmeaState++;
        INCF  bNmeaState,1
                        ;  }
                        ;  else
        GOTO  m130
                        ;    bNmeaState = 0;             // sorry...
m129    CLRF  bNmeaState
                        ;  return FALSE;
m130    BCF   0x03,Carry
        RETURN
                        ;
                        ;st12_Get_1m:
                        ;  bRx -= '0';                   // hopefully the 1 minute digit, convert to binary
m131    MOVLW .48
        SUBWF bRx_2,1
                        ;  if (bRx <= '9')               // 0..9?
        MOVLW .58
        SUBWF bRx_2,W
        BTFSC 0x03,Carry
        GOTO  m132
                        ;  {
                        ;    bMinute += bRx;             // yes, valid digit, add 10*10's + 1's
        MOVF  bRx_2,W
        ADDWF bMinute,1
                        ;    if (bMinute <= 59)          // valid minute?
        MOVLW .60
        SUBWF bMinute,W
        BTFSC 0x03,Carry
        GOTO  m133
                        ;      bNmeaState++;             // OK!
        INCF  bNmeaState,1
                        ;  }
                        ;  else
        GOTO  m133
                        ;    bNmeaState = 0;             // sorry...
m132    CLRF  bNmeaState
                        ;  return FALSE;
m133    BCF   0x03,Carry
        RETURN
                        ;
                        ;st13_Get_10s:
                        ;  bRx -= '0';                   // hopefully the 10 second digit, convert to binary
m134    MOVLW .48
        SUBWF bRx_2,1
                        ;  if (bRx <= '5')               // 0..5?
        MOVLW .54
        SUBWF bRx_2,W
        BTFSC 0x03,Carry
        GOTO  m135
                        ;  {
                        ;    bSecond = bRx;              // yes, valid digit
        MOVF  bRx_2,W
        MOVWF bSecond
                        ;    bSecond <<= 3;              // multiply by 10 the fast way ;-)
        BCF   0x03,Carry
        RLF   bSecond,1
        BCF   0x03,Carry
        RLF   bSecond,1
        BCF   0x03,Carry
        RLF   bSecond,1
                        ;    bSecond += bRx;
        ADDWF bSecond,1
                        ;    bSecond += bRx;
        ADDWF bSecond,1
                        ;    bNmeaState++;
        INCF  bNmeaState,1
                        ;  }
                        ;  else
        GOTO  m136
                        ;    bNmeaState = 0;             // sorry...
m135    CLRF  bNmeaState
                        ;  return FALSE;
m136    BCF   0x03,Carry
        RETURN
                        ;
                        ;st14_Get_1s:
                        ;  bNmeaState = 0;               // back to idle (this is the last state anyway)
m137    CLRF  bNmeaState
                        ;  bRx -= '0';                   // hopefully the 1 second digit, convert to binary
        MOVLW .48
        SUBWF bRx_2,1
                        ;  if (bRx <= '9')               // 0..9?
        MOVLW .58
        SUBWF bRx_2,W
        BTFSC 0x03,Carry
        GOTO  m138
                        ;  {
                        ;    bSecond += bRx;             // yes, valid digit, add 10*10's + 1's
        MOVF  bRx_2,W
        ADDWF bSecond,1
                        ;    oGLEDn = !oGLEDn;           // valid time found, toggle green LED (0.5Hz)
        MOVLW .16
        XORWF PORTA,1
                        ;    if ((bMinute.0 == 0) && (bSecond == 0)) // top of even minute?
        BTFSC bMinute,0
        GOTO  m138
        MOVF  bSecond,1
        BTFSS 0x03,Zero_
        GOTO  m138
                        ;      return TRUE;              // GO!
        BSF   0x03,Carry
        RETURN
                        ;  }
                        ;  return FALSE;
m138    BCF   0x03,Carry
        RETURN
                        ;}
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Refresh pin modes, feed the dog, refresh OPTION, turn off analog stuff
                        ; */
                        ;
                        ;void vRefreshMCU (void)
                        ;{
vRefreshMCU
                        ;  TRISA = TRISA_INIT;   // set default pin directions
        MOVLW .224
        BSF   0x03,RP0
        MOVWF TRISA
                        ;  TRISB = TRISB_INIT;
        MOVLW .14
        MOVWF TRISB
                        ;
                        ;  // Set up the OPTION register:
                        ;  //
                        ;  // Bit 7 = /RBPU  = 0, internal PORTB pull-up ON
                        ;  // Bit 6 = INTEDG = 1, RB0 interrupt on rising edge (not used)
                        ;  // Bit 5 = T0CS   = 0, internal TMR0 clock
                        ;  // Bit 4 = T0SE   = 1, TMR0 counts on falling edge on RA4 (not used)
                        ;  // Bit 3 = PSA    = 0, prescaler assigned to TMR0 (not WDT)
                        ;  // Bit 2..0 = PS2..PS0 = 111, TMR0 prescaler = 256 => 71.111ms overflow rate
                        ;
                        ;  clrwdt ();
        CLRWDT
                        ;  OPTION = 0b01010111;
        MOVLW .87
        MOVWF OPTION_REG
                        ;
                        ;  VRCON = 0;            // Vref module OFF to save a few electrons
        CLRF  VRCON
                        ;  CMCON = 0b00000111;   // comparators OFF, all PORTA pins digital
        MOVLW .7
        BCF   0x03,RP0
        MOVWF CMCON
                        ;  INTCON = 0b11000000;  // GIE = PEIE = 1 (needed for CCP1 interrupt)
        MOVLW .192
        MOVWF INTCON
                        ;}
        RETURN
                        ;
                        ;
                        ;/*------------------------------------------------------------------------------
                        ; *
                        ; *      Main program - This is the "reset entry point"
                        ; */
                        ;
                        ;void main (void)
                        ;{
main
                        ;  static char bSymbolIndex;
                        ;  static uns16 wRand;
                        ;  static bit qPrevExtSyncSample;
                        ;  bit qExtSyncEdge;
                        ;
                        ;  // Initialize the CPU
                        ;
                        ;  PORTA = PORTA_INIT;   // set initial output pin levels
        MOVLW .24
        BCF   0x03,RP0
        BCF   0x03,RP1
        MOVWF PORTA
                        ;  PORTB = PORTB_INIT;
        MOVLW .240
        MOVWF PORTB
                        ;
                        ;  vRefreshMCU ();       // set pin modes, critical registers etc.
        CALL  vRefreshMCU
                        ;
                        ;  clearRAM ();          // clear entire RAM
        BCF   0x03,IRP
        MOVLW .32
        MOVWF FSR
m139    CLRF  INDF
        BSF   FSR,7
        CLRF  INDF
        BCF   FSR,7
        INCF  FSR,1
        BTFSS FSR,7
        GOTO  m139
        BSF   0x03,IRP
        MOVLW .32
        MOVWF FSR
m140    CLRF  INDF
        INCF  FSR,1
        MOVLW .80
        SUBWF FSR,W
        BTFSS 0x03,Carry
        GOTO  m140
                        ;
                        ;  vInitDdsChip ();      // put the DDS in a known state
        CALL  vInitDdsChip
                        ;
                        ;  vProgMode ();         // go check if user wants to download some data
        BSF   0x03,RP0
        CALL  vProgMode
                        ;
                        ;  // Initialize UART for GPS NMEA reception
                        ;
                        ;  RCSTA = 0;                    // reset UART
        CLRF  RCSTA
                        ;
                        ;  switch (bReadEE (eaGPSBAUDCODE))
        MOVLW .51
        CALL  bReadEE
        XORLW .0
        BTFSC 0x03,Zero_
        GOTO  m141
        XORLW .1
        BTFSC 0x03,Zero_
        GOTO  m142
        XORLW .3
        BTFSC 0x03,Zero_
        GOTO  m143
        XORLW .1
        BTFSC 0x03,Zero_
        GOTO  m144
        XORLW .7
        BTFSC 0x03,Zero_
        GOTO  m145
        GOTO  m144
                        ;  {
                        ;    case 0: SPBRG = 47; break;  // 1200 baud with BRGH=0 and Fxtal=3.6864MHz
m141    MOVLW .47
        BSF   0x03,RP0
        MOVWF SPBRG
        GOTO  m146
                        ;    case 1: SPBRG = 23; break;  // 2400 baud
m142    MOVLW .23
        BSF   0x03,RP0
        MOVWF SPBRG
        GOTO  m146
                        ;    case 2: SPBRG = 11; break;  // 4800 baud
m143    MOVLW .11
        BSF   0x03,RP0
        MOVWF SPBRG
        GOTO  m146
                        ;    default:
                        ;    case 3: SPBRG = 5;  break;  // 9600 baud
m144    MOVLW .5
        BSF   0x03,RP0
        MOVWF SPBRG
        GOTO  m146
                        ;    case 4: SPBRG = 2;  break;  // 19200 baud
m145    MOVLW .2
        BSF   0x03,RP0
        MOVWF SPBRG
                        ;  }
                        ;  TXSTA = 0b00100000;   // 8-bit TX, TX on, asynch, BRGH=0 (low speed)
m146    MOVLW .32
        MOVWF TXSTA
                        ;  RCSTA = 0b10010000;   // UART on, 8-bit RX, continous RX, address detect off
        MOVLW .144
        BCF   0x03,RP0
        MOVWF RCSTA
                        ;
                        ;  // Here is the main "eternal" loop
                        ;
                        ;  for (;;)
                        ;  {
                        ;    // Keep pins pointing in appropriate directions (may change due to ESD) etc.
                        ;
                        ;    vRefreshMCU ();
m147    CALL  vRefreshMCU
                        ;
                        ;    // Falling edge detector for the external sync input
                        ;
                        ;    if (oEXT_SYNCn == 0)
        BTFSC PORTB,3
        GOTO  m148
                        ;    {
                        ;      if (qPrevExtSyncSample == 1)
        BTFSC 0x75,qPrevExtSyncSample
                        ;        qExtSyncEdge = TRUE;
        BSF   0x21,qExtSyncEdge
                        ;      qPrevExtSyncSample = 0;
        BCF   0x75,qPrevExtSyncSample
                        ;    }
                        ;    else
        GOTO  m149
                        ;      qPrevExtSyncSample = 1;
m148    BSF   0x75,qPrevExtSyncSample
                        ;
                        ;    if (CCP1IE == 0)            // tick interrupt disabled = TX idling?
m149    BSF   0x03,RP0
        BTFSC 0x8C,CCP1IE
        GOTO  m157
                        ;    {
                        ;      if (qExtSyncEdge || qGpsEvenMinute ()) // yes, is it time to start next frame now?
        BCF   0x03,RP0
        BTFSC 0x21,qExtSyncEdge
        GOTO  m150
        CALL  qGpsEvenMinute
        BTFSS 0x03,Carry
        GOTO  m147
                        ;      {
                        ;        uns16 wTxProbability;
                        ;
                        ;        // Generate a pseudo random number in the range 1..65536
                        ;
                        ;        if (wRand == 0)         // zero is not allowed as it would lock wRand at 0 so...
m150    MOVF  wRand,W
        IORWF wRand+1,W
        BTFSS 0x03,Zero_
        GOTO  m151
                        ;          wRand = 0x2BAD;       // ...initialize once with any non-zero seed
        MOVLW .173
        MOVWF wRand
        MOVLW .43
        MOVWF wRand+1
                        ;        Carry = 0;
m151    BCF   0x03,Carry
                        ;        wRand = rr (wRand);
        RRF   wRand+1,1
        RRF   wRand,1
                        ;        if (Carry)
        BTFSS 0x03,Carry
        GOTO  m152
                        ;        {
                        ;          wRand.high8 ^= 0xA1;
        MOVLW .161
        XORWF wRand+1,1
                        ;          wRand.low8 ^= 0xA1;
        XORWF wRand,1
                        ;        }
                        ;
                        ;        wTxProbability.low8 = bReadEE (eaTXPROB); // read probability threshold setting from EEPROM
m152    MOVLW .52
        CALL  bReadEE
        MOVWF wTxProbability
                        ;        wTxProbability.high8 = bReadEE (eaTXPROB+1);
        MOVLW .53
        CALL  bReadEE
        MOVWF wTxProbability+1
                        ;
                        ;        if (wRand <= wTxProbability)          // did we get a "statistical yes"?
        MOVF  wRand+1,W
        SUBWF wTxProbability+1,W
        BTFSS 0x03,Carry
        GOTO  m156
        BTFSS 0x03,Zero_
        GOTO  m153
        MOVF  wRand,W
        SUBWF wTxProbability,W
        BTFSS 0x03,Carry
        GOTO  m156
                        ;        {
                        ;          wTick10Length.low8 = bReadEE (eaBAUDCAL);     // get 16-bit signed baud calibration value from EEPROM
m153    MOVLW .54
        CALL  bReadEE
        MOVWF wTick10Length
                        ;          wTick10Length.high8 = bReadEE (eaBAUDCAL+1);
        MOVLW .55
        CALL  bReadEE
        MOVWF wTick10Length+1
                        ;          wTick10Length += 39322;                       // add nominal time for 10:th tick
        MOVLW .153
        ADDWF wTick10Length+1,1
        MOVLW .154
        ADDWF wTick10Length,1
        BTFSC 0x03,Carry
        INCF  wTick10Length+1,1
                        ;
                        ;          vInitDdsChip ();      // just in case the DDS was disconnected and reconnected...
        CALL  vInitDdsChip
                        ;          T1CON = 0b00000000;   // prescaler = 1, no oscillator, internal clock, TMR1 off
        CLRF  T1CON
                        ;          CCP1CON = 0b00001010; // compare mode, software interrupt, CCP1 pin unaffected
        MOVLW .10
        MOVWF CCP1CON
                        ;
                        ;          // Nominal start time for the first message symbol is top of even minute plus
                        ;          // 2 seconds. In case of GPS sync, we will delay the transmission start until
                        ;          // ~1.14s after receiving full even minute from the GPS. This allows for some
                        ;          // delay in the NMEA serial output but is still acceptable (WSPR sync search
                        ;          // is +/-5s according to Joe K1JT). In case of external pin sync, a start delay
                        ;          // of ~1.99s is used.
                        ;
                        ;          TMR1L = 0;                          // start TMR1 from zero
        CLRF  TMR1L
                        ;          TMR1H = 0;
        CLRF  TMR1H
                        ;          CCPR1L = 0;                         // first compare interrupt after a full TMR1 cycle
        CLRF  CCPR1L
                        ;          CCPR1H = 0;
        CLRF  CCPR1H
                        ;          if (qExtSyncEdge)                   // external sync?
        BTFSS 0x21,qExtSyncEdge
        GOTO  m154
                        ;            jIsrGlobals.bTickCycleCount = 28; // yes, start delay = 28 full TMR1 cycles = ~1.99s
        MOVLW .28
        MOVWF jIsrGlobals+1
                        ;          else
        GOTO  m155
                        ;            jIsrGlobals.bTickCycleCount = 16; // no, GPS, start delay = 16 full TMR1 cycles = ~1.14s
m154    MOVLW .16
        MOVWF jIsrGlobals+1
                        ;          jIsrGlobals.qPleaseQRT = FALSE;     // don't QRT prematurely...
m155    BCF   jIsrGlobals+2,1
                        ;          vEnqueueSymbol (bGetSymbol (0));    // load first symbol for transmission
        MOVLW .0
        CALL  bGetSymbol
        CALL  vEnqueueSymbol
                        ;          bSymbolIndex = 0;                   // symbol # currently in transmission
        CLRF  bSymbolIndex_2
                        ;          CCP1IE = 1;                         // enable CCP1 interrupt (GIE & PEIE are set elsewhere)
        BSF   0x8C,CCP1IE
                        ;          TMR1ON = 1;                         // GO!
        BCF   0x03,RP0
        BSF   0x10,TMR1ON
                        ;        }
                        ;
                        ;        qExtSyncEdge = FALSE;                 // we have responded to the sync flag, clear it
m156    BCF   0x21,qExtSyncEdge
                        ;
                        ;      } // end of "if any TX sync"
                        ;    }
                        ;    else      // CCP1IE == 1, ISR hasn't disabled itself yet, TX is still in progress
        GOTO  m147
                        ;    if (jIsrGlobals.qNewFreqInQueue == FALSE)           // is th ISR ready for symbol update?
m157    BCF   0x03,RP0
        BTFSC jIsrGlobals+2,0
        GOTO  m147
                        ;    {
                        ;      // When the transmission has been started, the ISR will run the
                        ;      // whole show in the background. Here, we just have to feed the ISR
                        ;      // with a new symbol as soon as it has consumed the previous one
                        ;      // (handshaking through the flag jIsrGlobals.qNewFreqInQueue).
                        ;
                        ;      bSymbolIndex++;                                   // yes, bump symbol pointer
        INCF  bSymbolIndex_2,1
                        ;      if (bSymbolIndex < 162)                           // end of message?
        MOVLW .162
        SUBWF bSymbolIndex_2,W
        BTFSC 0x03,Carry
        GOTO  m158
                        ;        vEnqueueSymbol (bGetSymbol (bSymbolIndex));     // no, put the symbol in the queue
        MOVF  bSymbolIndex_2,W
        CALL  bGetSymbol
        CALL  vEnqueueSymbol
                        ;      else                                              // yes, transmission of last symbol has already started
        BCF   0x03,RP0
        GOTO  m147
                        ;      {
                        ;        vPrepareDdsForQsyTo (0);                        // make next symbol zero Hz = key-up
m158    CLRF  ulNewPhaseIncrement
        CLRF  ulNewPhaseIncrement+1
        CLRF  ulNewPhaseIncrement+2
        CLRF  ulNewPhaseIncrement+3
        CALL  vPrepareDdsForQsyTo
                        ;        jIsrGlobals.qPleaseQRT = TRUE;                  // tell ISR to key-up and quit after DDS update
        BSF   jIsrGlobals+2,1
                        ;        jIsrGlobals.qNewFreqInQueue = TRUE;
        BSF   jIsrGlobals+2,0
                        ;      }
                        ;    }
                        ;
                        ;  } // end of main loop
        GOTO  m147

        END


; *** KEY INFO ***

; 0x0004   40 word(s)  1 % : vIntServer
; 0x0202    6 word(s)  0 % : bReadEE
; 0x0208   27 word(s)  1 % : qWriteEE
; 0x0223    6 word(s)  0 % : vPut
; 0x0229   19 word(s)  0 % : vPrint
; 0x002C  470 word(s) 22 % : _const1
; 0x023C   29 word(s)  1 % : vPutHexByte
; 0x0259   24 word(s)  1 % : bGetSymbol
; 0x0271  219 word(s) 10 % : vDumpSettings
; 0x034C   21 word(s)  1 % : vPrintUpdateResult
; 0x0361   13 word(s)  0 % : vPrintNotUpdated
; 0x036E  611 word(s) 29 % : vProgMode
; 0x05D1   22 word(s)  1 % : vPrepareDdsForQsyTo
; 0x05E7   14 word(s)  0 % : vInitDdsChip
; 0x05F5   60 word(s)  2 % : vEnqueueSymbol
; 0x0631  247 word(s) 12 % : qGpsEvenMinute
; 0x0728   15 word(s)  0 % : vRefreshMCU
; 0x0737  179 word(s)  8 % : main

; RAM usage: 86 bytes (74 local), 138 bytes free
; Maximum call level: 4 (+1 for interrupt)
; Total of 2023 code words (98 %)
